VERSION 5.00
Begin VB.UserControl ProgressBar 
   ClientHeight    =   465
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   PropertyPages   =   "ProgressBar.ctx":0000
   ScaleHeight     =   31
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "ProgressBar.ctx":0038
End
Attribute VB_Name = "ProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit



Option Base 0
Private Type RGB
    Red As Byte
    Green As Byte
    Blue As Byte
End Type

Private Type GRADIENTSTRUCT
    BaseColor As Long
    FinalColor As Long
    Percentage As Single
End Type
'' Global Variables for Unicode (Used By the Text Functions)

Private Unicode_Checked As Boolean
Private Using_Unicode As Boolean

Private Const c_AlphaStr As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789!@#$%^&*()_-+=~`[]{}\|;:'<>,./?"


'' ****** CONSTANTS ******


''' Point structures for scale widths and heights

Private Const CS_BYTEALIGNCLIENT = &H1000
Private Const CS_BYTEALIGNWINDOW = &H2000
Private Const CS_CLASSDC = &H40
Private Const CS_DBLCLKS = &H8
Private Const CS_HREDRAW = &H2
Private Const CS_INSERTCHAR = &H2000
Private Const CS_KEYCVTWINDOW = &H4
Private Const CS_NOCLOSE = &H200
Private Const CS_NOKEYCVT = &H100
Private Const CS_NOMOVECARET = &H4000
Private Const CS_OWNDC = &H20
Private Const CS_PARENTDC = &H80
Private Const CS_privateCLASS = &H4000
Private Const CS_SAVEBITS = &H800
Private Const CS_VREDRAW = &H1
Private Const CT_CTYPE1 = &H1
Private Const CT_CTYPE2 = &H2
Private Const CT_CTYPE3 = &H4
Private Const CTLCOLOR_BTN = 3
Private Const CTLCOLOR_DLG = 4
Private Const CTLCOLOR_EDIT = 1
Private Const CTLCOLOR_LISTBOX = 2
Private Const CTLCOLOR_MAX = 8
Private Const CTLCOLOR_MSGBOX = 0&
Private Const CTLCOLOR_SCROLLBAR = 5
Private Const CTLCOLOR_STATIC = 6

''' Window Creation

'' Window Styles 1

Private Const WS_OVERLAPPED = &H0&
Private Const WS_POPUP = &H80000000
Private Const WS_CHILD = &H40000000
Private Const WS_MINIMIZE = &H20000000
Private Const WS_VISIBLE = &H10000000
Private Const WS_DISABLED = &H8000000
Private Const WS_CLIPSIBLINGS = &H4000000
Private Const WS_CLIPCHILDREN = &H2000000
Private Const WS_MAXIMIZE = &H1000000
Private Const WS_CAPTION = &HC00000
Private Const WS_BORDER = &H800000
Private Const WS_DLGFRAME = &H400000
Private Const WS_VSCROLL = &H200000
Private Const WS_HSCROLL = &H100000
Private Const WS_SYSMENU = &H80000
Private Const WS_THICKFRAME = &H40000
Private Const WS_GROUP = &H20000
Private Const WS_TABSTOP = &H10000

Private Const WS_MINIMIZEBOX = &H20000
Private Const WS_MAXIMIZEBOX = &H10000

Private Const WS_TILED = WS_OVERLAPPED
Private Const WS_ICONIC = WS_MINIMIZE
Private Const WS_SIZEBOX = WS_THICKFRAME

'' Window Styles 2

Private Const WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED + _
                 WS_CAPTION + _
                 WS_SYSMENU + _
                 WS_THICKFRAME + _
                 WS_MINIMIZEBOX + _
                 WS_MAXIMIZEBOX)

Private Const WS_POPUPWINDOW = (WS_POPUP + _
                 WS_BORDER + _
                 WS_SYSMENU)

Private Const WS_CHILDWINDOW = (WS_CHILD)

Private Const WS_TILEDWINDOW = WS_OVERLAPPEDWINDOW
 '
 ' Extended Window Styles
 '
Private Const WS_EX_DLGMODALFRAME = &H1&
Private Const WS_EX_NOPARENTNOTIFY = &H4&
Private Const WS_EX_TOPMOST = &H8&
Private Const WS_EX_ACCEPTFILES = &H10&
Private Const WS_EX_TRANSPARENT = &H20&

Private Const WS_EX_MDICHILD = &H40&
Private Const WS_EX_TOOLWINDOW = &H80&
Private Const WS_EX_WINDOWEDGE = &H100&
Private Const WS_EX_CLIENTEDGE = &H200&
Private Const WS_EX_CONTEXTHELP = &H400&

Private Const WS_EX_RIGHT = &H1000&
Private Const WS_EX_LEFT = &H0&
Private Const WS_EX_RTLREADING = &H2000&
Private Const WS_EX_LTRREADING = &H0&
Private Const WS_EX_LEFTSCROLLBAR = &H4000&
Private Const WS_EX_RIGHTSCROLLBAR = &H0&

Private Const WS_EX_CONTROLPARENT = &H10000
Private Const WS_EX_STATICEDGE = &H20000
Private Const WS_EX_APPWINDOW = &H40000

Private Const WS_EX_OVERLAPPEDWINDOW = (WS_EX_WINDOWEDGE + WS_EX_CLIENTEDGE)
Private Const WS_EX_PALETTEWINDOW = (WS_EX_WINDOWEDGE + WS_EX_TOOLWINDOW + WS_EX_TOPMOST)


' Windows 5.0& (2000/Millenium)

Private Const WS_EX_LAYERED = &H80000

Private Const WS_EX_NOINHERITLAYOUT = &H100000     ' Disable inheritence of mirroring by children
Private Const WS_EX_LAYOUTRTL = &H400000           ' Right to left mirroring

' Windows NT 5.0& (Windows 2000) only

Private Const WS_EX_NOACTIVATE = &H8000000


' Windows Virtual Key Code Constants

Private Const VK_LBUTTON = &H1
Private Const VK_RBUTTON = &H2
Private Const VK_CANCEL = &H3
Private Const VK_MBUTTON = &H4           ' NOT contiguous with L & RBUTTON ''

Private Const VK_BACK = &H8
Private Const VK_TAB = &H9

Private Const VK_SEMICOLON = &H27

Private Const VK_QUOTE = &H28
Private Const VK_BACK_QUOTE = &H29

Private Const VK_SLASH = &H35
Private Const VK_BACK_SLASH = &H2B

Private Const VK_PERIOD = &H34
Private Const VK_COMMA = &H33

Private Const VK_LEFT_BRACE = &H1A
Private Const VK_RIGHT_BRACE = &H1B

Private Const VK_DASH = &HC
Private Const VK_EQUAL = &HD

Private Const VK_CLEAR = &HC
Private Const VK_RETURN = &HD

Private Const VK_SHIFT = &H10
Private Const VK_CONTROL = &H11
Private Const VK_MENU = &H12
Private Const VK_PAUSE = &H13
Private Const VK_CAPITAL = &H14

Private Const VK_KANA = &H15
Private Const VK_HANGEUL = &H15        ' old name - should be here for compatibility ''
Private Const VK_HANGUL = &H15
Private Const VK_JUNJA = &H17
Private Const VK_FINAL = &H18
Private Const VK_HANJA = &H19
Private Const VK_KANJI = &H19

Private Const VK_ESCAPE = &H1B

Private Const VK_CONVERT = &H1C
Private Const VK_NONCONVERT = &H1D
Private Const VK_ACCEPT = &H1E
Private Const VK_MODECHANGE = &H1F

Private Const VK_SPACE = &H20
Private Const VK_PRIOR = &H21
Private Const VK_NEXT = &H22
Private Const VK_END = &H23
Private Const VK_HOME = &H24
Private Const VK_LEFT = &H25
Private Const VK_UP = &H26
Private Const VK_RIGHT = &H27
Private Const VK_DOWN = &H28
Private Const VK_SELECT = &H29
Private Const VK_PRINT = &H2A
Private Const VK_EXECUTE = &H2B
Private Const VK_SNAPSHOT = &H2C
Private Const VK_INSERT = &H2D
Private Const VK_DELETE = &H2E
Private Const VK_HELP = &H2F

' VK_0& thru VK_9 are the same as ASCII '0&' thru '9' (=&H30 - =&H39) ''
' VK_A thru VK_Z are the same as ASCII 'A' thru 'Z' (=&H41 - =&H5A) ''

Private Const VK_LWIN = &H5B
Private Const VK_RWIN = &H5C
Private Const VK_APPS = &H5D

Private Const VK_NUMPAD0 = &H60
Private Const VK_NUMPAD1 = &H61
Private Const VK_NUMPAD2 = &H62
Private Const VK_NUMPAD3 = &H63
Private Const VK_NUMPAD4 = &H64
Private Const VK_NUMPAD5 = &H65
Private Const VK_NUMPAD6 = &H66
Private Const VK_NUMPAD7 = &H67
Private Const VK_NUMPAD8 = &H68
Private Const VK_NUMPAD9 = &H69
Private Const VK_MULTIPLY = &H6A
Private Const VK_ADD = &H6B
Private Const VK_SEPARATOR = &H6C
Private Const VK_SUBTRACT = &H6D
Private Const VK_DECIMAL = &H6E
Private Const VK_DIVIDE = &H6F
Private Const VK_F1 = &H70
Private Const VK_F2 = &H71
Private Const VK_F3 = &H72
Private Const VK_F4 = &H73
Private Const VK_F5 = &H74
Private Const VK_F6 = &H75
Private Const VK_F7 = &H76
Private Const VK_F8 = &H77
Private Const VK_F9 = &H78
Private Const VK_F10 = &H79
Private Const VK_F11 = &H7A
Private Const VK_F12 = &H7B
Private Const VK_F13 = &H7C
Private Const VK_F14 = &H7D
Private Const VK_F15 = &H7E
Private Const VK_F16 = &H7F
Private Const VK_F17 = &H80
Private Const VK_F18 = &H81
Private Const VK_F19 = &H82
Private Const VK_F20 = &H83
Private Const VK_F21 = &H84
Private Const VK_F22 = &H85
Private Const VK_F23 = &H86
Private Const VK_F24 = &H87

Private Const VK_NUMLOCK = &H90
Private Const VK_SCROLL = &H91

'
' * VK_L* & VK_R* - left and right Alt, Ctrl and Shift virtual keys.
' * Used only as parameters to GetAsyncKeyState() and GetKeyState().
' * No other API or message will distinguish left and right keys in this way.
 ''
Private Const VK_LSHIFT = &HA0
Private Const VK_RSHIFT = &HA1
Private Const VK_LCONTROL = &HA2
Private Const VK_RCONTROL = &HA3
Private Const VK_LMENU = &HA4
Private Const VK_RMENU = &HA5

'' if (WINVER >= =&H0400)
Private Const VK_PROCESSKEY = &HE5
'' end if ' WINVER >= =&H0400 ''

Private Const VK_ATTN = &HF6
Private Const VK_CRSEL = &HF7
Private Const VK_EXSEL = &HF8
Private Const VK_EREOF = &HF9
Private Const VK_PLAY = &HFA
Private Const VK_ZOOM = &HFB
Private Const VK_NONAME = &HFC
Private Const VK_PA1 = &HFD
Private Const VK_OEM_CLEAR = &HFE


'' System Command Constants

Private Const SC_ARRANGE = &HF110&
Private Const SC_CLOSE = &HF060&
Private Const SC_HOTKEY = &HF150&
Private Const SC_HSCROLL = &HF080&
Private Const SC_KEYMENU = &HF100&
Private Const SC_MAXIMIZE = &HF030&
Private Const SC_MINIMIZE = &HF020&
Private Const SC_MOUSEMENU = &HF090&
Private Const SC_MOVE = &HF010&
Private Const SC_NEXTWINDOW = &HF040&
Private Const SC_PREVWINDOW = &HF050&
Private Const SC_RESTORE = &HF120&
Private Const SC_SCREENSAVE = &HF140&
Private Const SC_SIZE = &HF000&
Private Const SC_TASKLIST = &HF130&
Private Const SC_VSCROLL = &HF070&

Private Const SC_ICON = SC_MINIMIZE
Private Const SC_ZOOM = SC_MAXIMIZE



'' Windows Hooks

Private Const WH_CALLWNDPROC = 4
Private Const WH_CBT = 5
Private Const WH_DEBUG = 9
Private Const WH_FOREGROUNDIDLE = 11
Private Const WH_GETMESSAGE = 3
Private Const WH_HARDWARE = 8
Private Const WH_JOURNALPLAYBACK = 1
Private Const WH_JOURNALRECORD = 0
Private Const WH_KEYBOARD = 2
Private Const WH_MAX = 11
Private Const WH_MIN = (-1)
Private Const WH_MOUSE = 7
Private Const WH_MSGFILTER = (-1)
Private Const WH_SHELL = 10
Private Const WH_SYSMSGFILTER = 6


'' Platform Version Constants

Private Const VER_PLATFORM_WIN32_NT = 2
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32s = 0&

''' Drawing and Device Context

'' Owner-drawn actions

Private Const ODA_DRAWENTIRE = &H1
Private Const ODA_FOCUS = &H4
Private Const ODA_SELECT = &H2

'' Owner-drawn states

Private Const ODS_CHECKED = &H8
Private Const ODS_DISABLED = &H4
Private Const ODS_FOCUS = &H10
Private Const ODS_GRAYED = &H2
Private Const ODS_SELECTED = &H1
Private Const ODS_DEFAULT = &H20
Private Const ODS_HOTLIGHT = &H40
Private Const ODS_NOACCEL = &H100
Private Const ODS_MENUACTIVATE = (&H1000)

'' Owner-drawn types

Private Const ODT_BUTTON = 4
Private Const ODT_COMBOBOX = 3
Private Const ODT_LISTBOX = 2
Private Const ODT_MENU = 1

'' DrawText Constants

Private Const DT_BOTTOM = &H8
Private Const DT_CALCRECT = &H400
Private Const DT_CENTER = &H1
Private Const DT_CHARSTREAM = 4
Private Const DT_DISPFILE = 6
Private Const DT_EXPANDTABS = &H40
Private Const DT_EXTERNALLEADING = &H200
Private Const DT_INTERNAL = &H1000
Private Const DT_LEFT = &H0
Private Const DT_METAFILE = 5
Private Const DT_NOCLIP = &H100
Private Const DT_NOPREFIX = &H800
Private Const DT_PLOTTER = 0&
Private Const DT_RASCAMERA = 3
Private Const DT_RASDISPLAY = 1
Private Const DT_RASPRINTER = 2
Private Const DT_RIGHT = &H2
Private Const DT_SINGLELINE = &H20
Private Const DT_TABSTOP = &H80
Private Const DT_TOP = &H0
Private Const DT_VCENTER = &H4
Private Const DT_WORDBREAK = &H10

'' 3D Border Styles

Private Const BDR_INNER = &HC
Private Const BDR_OUTER = &H3
Private Const BDR_RAISED = &H5
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKEN = &HA
Private Const BDR_SUNKENINNER = &H8
Private Const BDR_SUNKENOUTER = &H2

'' More 3D Border Styles

Private Const BF_ADJUST = &H2000
Private Const BF_BOTTOM = &H8
Private Const BF_DIAGONAL = &H10
Private Const BF_FLAT = &H4000
Private Const BF_LEFT = &H1
Private Const BF_MIDDLE = &H800
Private Const BF_MONO = &H8000
Private Const BF_RIGHT = &H4
Private Const BF_SOFT = &H1000
Private Const BF_TOP = &H2
Private Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Private Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Private Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Private Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Private Const BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM Or BF_LEFT)
Private Const BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM Or BF_RIGHT)
Private Const BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP Or BF_LEFT)
Private Const BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP Or BF_RIGHT)

Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)

'' System Colors


Private Const COLOR_ACTIVEBORDER = 10
Private Const COLOR_ACTIVECAPTION = 2
Private Const COLOR_GRADIENTACTIVECAPTION = 27
Private Const COLOR_ADJ_MAX = 100
Private Const COLOR_ADJ_MIN = -100
Private Const COLOR_APPWORKSPACE = 12
Private Const COLOR_BACKGROUND = 1
Private Const COLOR_BTNFACE = 15
Private Const COLOR_BTNHIGHLIGHT = 20
Private Const COLOR_BTNSHADOW = 16
Private Const COLOR_BTNTEXT = 18
Private Const COLOR_CAPTIONTEXT = 9
Private Const COLOR_GRAYTEXT = 17
Private Const COLOR_HIGHLIGHT = 13
Private Const COLOR_HIGHLIGHTTEXT = 14
Private Const COLOR_INACTIVEBORDER = 11
Private Const COLOR_INACTIVECAPTION = 3
Private Const COLOR_GRADIENTINACTIVECAPTION = 28
Private Const COLOR_INACTIVECAPTIONTEXT = 19
Private Const COLOR_MENU = 4
Private Const COLOR_MENUTEXT = 7
Private Const COLOR_SCROLLBAR = 0
Private Const COLOR_WINDOW = 5
Private Const COLOR_WINDOWFRAME = 6
Private Const COLOR_WINDOWTEXT = 8

Private Const COLOR_3DDKSHADOW = 21
Private Const COLOR_3DLIGHT = 22
Private Const COLOR_INFOTEXT = 23
Private Const COLOR_INFOBK = 24

' Windows 98/2000

Private Const COLOR_HOTLIGHT = 26

'' Draw Modes

Private Const OPAQUE = 2
Private Const TRANSPARENT = 1

'' Text Alignment

Private Const TA_BASELINE = 24
Private Const TA_BOTTOM = 8
Private Const TA_CENTER = 6
Private Const TA_LEFT = 0&
Private Const TA_NOUPDATECP = 0&
Private Const TA_RIGHT = 2
Private Const TA_TOP = 0&
Private Const TA_UPDATECP = 1

Private Const TA_MASK = (TA_BASELINE + TA_CENTER + TA_UPDATECP)

'' Check states.

Private Const DRWCHK_NORMAL = 0&
Private Const DRWCHK_SELECTED = 1
Private Const DRWCHK_DISABLED = 2

'' Draw Types

Private Const DST_COMPLEX = &H0
Private Const DST_TEXT = &H1
Private Const DST_PREFIXTEXT = &H2
Private Const DST_ICON = &H3
Private Const DST_BITMAP = &H4

'' Draw states

Private Const DSS_NORMAL = &H0
Private Const DSS_UNION = &H10         ' Gray string appearance '
Private Const DSS_DISABLED = &H20
Private Const DSS_MONO = &H80
Private Const DSS_RIGHT = &H8000

Private Const TPM_LEFTBUTTON = &H0&
Private Const TPM_RIGHTBUTTON = &H2&
Private Const TPM_LEFTALIGN = &H0&
Private Const TPM_CENTERALIGN = &H4&
Private Const TPM_RIGHTALIGN = &H8&

Private Const TPM_TOPALIGN = &H0&
Private Const TPM_VCENTERALIGN = &H10&
Private Const TPM_BOTTOMALIGN = &H20&

Private Const TPM_HORIZONTAL = &H0&            '' Horz alignment matters more ''
Private Const TPM_VERTICAL = &H40&             '' Vert alignment matters more ''
Private Const TPM_NONOTIFY = &H80&             '' Don't send any notification msgs ''
Private Const TPM_RETURNCMD = &H100&

Private Const TPM_RECURSE = &H1&

'' LOGFONT face size

Private Const LF_FACESIZE = 32
Private Const LF_FULLFACESIZE = 64

'' GetObject object constants

Private Const OBJ_BITMAP = 7
Private Const OBJ_BRUSH = 2
Private Const OBJ_DC = 3
Private Const OBJ_ENHMETADC = 12
Private Const OBJ_ENHMETAFILE = 13
Private Const OBJ_EXTPEN = 11
Private Const OBJ_FONT = 6
Private Const OBJ_MEMDC = 10
Private Const OBJ_METADC = 4
Private Const OBJ_METAFILE = 9
Private Const OBJ_PAL = 5
Private Const OBJ_PEN = 1
Private Const OBJ_REGION = 8

' Gradient Fill flags ' Windows 2000

Private Const GRADIENT_FILL_RECT_H = &H0&
Private Const GRADIENT_FILL_RECT_V = &H1&
Private Const GRADIENT_FILL_TRIANGLE = &H2&
Private Const GRADIENT_FILL_OP_FLAG = &HFF&

' Brush Styles

Private Const BS_DIBPATTERN = 5
Private Const BS_DIBPATTERN8X8 = 8
Private Const BS_DIBPATTERNPT = 6
Private Const BS_HATCHED = 2
Private Const BS_NULL = 1
Private Const BS_HOLLOW = BS_NULL
Private Const BS_PATTERN = 3
Private Const BS_PATTERN8X8 = 7
Private Const BS_SOLID = 0&

'' Hatch brush constants

Private Const HS_BDIAGONAL = 3
Private Const HS_BDIAGONAL1 = 7
Private Const HS_CROSS = 4
Private Const HS_DIAGCROSS = 5
Private Const HS_DITHEREDBKCLR = 24
Private Const HS_DITHEREDCLR = 20
Private Const HS_DITHEREDTEXTCLR = 22
Private Const HS_FDIAGONAL = 2
Private Const HS_FDIAGONAL1 = 6
Private Const HS_HALFTONE = 18
Private Const HS_HORIZONTAL = 0&
Private Const HS_NOSHADE = 17
Private Const HS_SOLID = 8
Private Const HS_SOLIDBKCLR = 23
Private Const HS_SOLIDCLR = 19
Private Const HS_SOLIDTEXTCLR = 21
Private Const HS_VERTICAL = 1

' Pen Styles

Private Const PS_ALTERNATE = 8
Private Const PS_COSMETIC = &H0
Private Const PS_DASH = 1
Private Const PS_DASHDOT = 3
Private Const PS_DASHDOTDOT = 4
Private Const PS_DOT = 2
Private Const PS_ENDCAP_FLAT = &H200
Private Const PS_ENDCAP_MASK = &HF00
Private Const PS_ENDCAP_ROUND = &H0
Private Const PS_ENDCAP_SQUARE = &H100
Private Const PS_GEOMETRIC = &H10000
Private Const PS_INSIDEFRAME = 6
Private Const PS_JOIN_BEVEL = &H1000
Private Const PS_JOIN_MASK = &HF000
Private Const PS_JOIN_MITER = &H2000
Private Const PS_JOIN_ROUND = &H0
Private Const PS_NULL = 5
Private Const PS_SOLID = 0&
Private Const PS_STYLE_MASK = &HF
Private Const PS_ptcMASK = &HF0000
Private Const PS_USERSTYLE = 7

Private Const IMC_SETSTATUSWINDOWPOS = &H10
Private Const IMC_SETCOMPOSITIONWINDOW = &HC
Private Const IMC_SETCOMPOSITIONFONT = &HA
Private Const IMC_SETCANDIDATEPOS = &H8
Private Const IMC_OPENSTATUSWINDOW = &H22
Private Const IMC_GETSTATUSWINDOWPOS = &HF
Private Const IMC_GETCOMPOSITIONWINDOW = &HB
Private Const IMC_GETCOMPOSITIONFONT = &H9
Private Const IMC_GETCANDIDATEPOS = &H7
Private Const IMC_CLOSESTATUSWINDOW = &H21

' GetDeviceCaps parameters

Private Const LOGPIXELSX = 88
Private Const LOGPIXELSY = 90

' System Parameters info constants (to retrieve the current non-client font)

Private Const SPI_GETACCESSTIMEOUT = 60
Private Const SPI_GETANIMATION = 72
Private Const SPI_GETBEEP = 1
Private Const SPI_GETBORDER = 5
Private Const SPI_GETDEFAULTINPUTLANG = 89
Private Const SPI_GETDRAGFULLWINDOWS = 38
Private Const SPI_GETFASTTASKSWITCH = 35
Private Const SPI_GETFILTERKEYS = 50
Private Const SPI_GETFONTSMOOTHING = 74
Private Const SPI_GETGRIDGRANULARITY = 18
Private Const SPI_GETHIGHCONTRAST = 66
Private Const SPI_GETICONMETRICS = 45
Private Const SPI_GETICONTITLELOGFONT = 31
Private Const SPI_GETICONTITLEWRAP = 25
Private Const SPI_GETKEYBOARDDELAY = 22
Private Const SPI_GETKEYBOARDPREF = 68
Private Const SPI_GETKEYBOARDSPEED = 10
Private Const SPI_GETLOWPOWERACTIVE = 83
Private Const SPI_GETLOWPOWERTIMEOUT = 79
Private Const SPI_GETMENUDROPALIGNMENT = 27
Private Const SPI_GETMINIMIZEDMETRICS = 43
Private Const SPI_GETMOUSE = 3
Private Const SPI_GETMOUSEKEYS = 54
Private Const SPI_GETMOUSETRAILS = 94
Private Const SPI_GETNONCLIENTMETRICS = 41
Private Const SPI_GETPOWEROFFACTIVE = 84
Private Const SPI_GETPOWEROFFTIMEOUT = 80
Private Const SPI_GETSCREENREADER = 70
Private Const SPI_GETSCREENSAVEACTIVE = 16
Private Const SPI_GETSCREENSAVETIMEOUT = 14
Private Const SPI_GETSERIALKEYS = 62
Private Const SPI_GETSHOWSOUNDS = 56
Private Const SPI_GETSOUNDSENTRY = 64
Private Const SPI_GETSTICKYKEYS = 58
Private Const SPI_GETTOGGLEKEYS = 52
Private Const SPI_GETWINDOWSEXTENSION = 92
Private Const SPI_GETWORKAREA = 48

Private Const SPI_ICONHORIZONTALSPACING = 13
Private Const SPI_ICONVERTICALSPACING = 24

Private Const SPI_LANGDRIVER = 12

Private Const SPI_SCREENSAVERRUNNING = 97

Private Const SPI_SETACCESSTIMEOUT = 61
Private Const SPI_SETANIMATION = 73
Private Const SPI_SETBEEP = 2
Private Const SPI_SETBORDER = 6
Private Const SPI_SETCURSORS = 87
Private Const SPI_SETDEFAULTINPUTLANG = 90
Private Const SPI_SETDESKPATTERN = 21
Private Const SPI_SETDESKWALLPAPER = 20
Private Const SPI_SETDOUBLECLICKTIME = 32
Private Const SPI_SETDOUBLECLKHEIGHT = 30
Private Const SPI_SETDOUBLECLKWIDTH = 29
Private Const SPI_SETDRAGFULLWINDOWS = 37
Private Const SPI_SETDRAGHEIGHT = 77
Private Const SPI_SETDRAGWIDTH = 76
Private Const SPI_SETFASTTASKSWITCH = 36
Private Const SPI_SETFILTERKEYS = 51
Private Const SPI_SETFONTSMOOTHING = 75
Private Const SPI_SETGRIDGRANULARITY = 19
Private Const SPI_SETHANDHELD = 78
Private Const SPI_SETHIGHCONTRAST = 67
Private Const SPI_SETICONMETRICS = 46
Private Const SPI_SETICONS = 88
Private Const SPI_SETICONTITLELOGFONT = 34
Private Const SPI_SETICONTITLEWRAP = 26
Private Const SPI_SETKEYBOARDDELAY = 23
Private Const SPI_SETKEYBOARDPREF = 69
Private Const SPI_SETKEYBOARDSPEED = 11
Private Const SPI_SETLANGTOGGLE = 91
Private Const SPI_SETLOWPOWERACTIVE = 85
Private Const SPI_SETLOWPOWERTIMEOUT = 81
Private Const SPI_SETMENUDROPALIGNMENT = 28
Private Const SPI_SETMINIMIZEDMETRICS = 44
Private Const SPI_SETMOUSE = 4
Private Const SPI_SETMOUSEBUTTONSWAP = 33
Private Const SPI_SETMOUSEKEYS = 55
Private Const SPI_SETMOUSETRAILS = 93
Private Const SPI_SETNONCLIENTMETRICS = 42
Private Const SPI_SETPENWINDOWS = 49
Private Const SPI_SETPOWEROFFACTIVE = 86
Private Const SPI_SETPOWEROFFTIMEOUT = 82
Private Const SPI_SETSCREENREADER = 71
Private Const SPI_SETSCREENSAVEACTIVE = 17
Private Const SPI_SETSCREENSAVETIMEOUT = 15
Private Const SPI_SETSERIALKEYS = 63
Private Const SPI_SETSHOWSOUNDS = 57
Private Const SPI_SETSOUNDSENTRY = 65
Private Const SPI_SETSTICKYKEYS = 59
Private Const SPI_SETTOGGLEKEYS = 53
Private Const SPI_SETWORKAREA = 47

Private Const SPI_GETMENUSHOWDELAY = 106
Private Const SPI_SETMENUSHOWDELAY = 107
Private Const SPI_GETMENUANIMATION = &H1002
Private Const SPI_SETMENUANIMATION = &H1003
Private Const SPI_GETKEYBOARDCUES = &H100A
Private Const SPI_SETKEYBOARDCUES = &H100B
Private Const SPI_GETMENUUNDERLINES = SPI_GETKEYBOARDCUES
Private Const SPI_SETMENUUNDERLINES = SPI_SETKEYBOARDCUES
Private Const SPI_GETMENUFADE = &H1012
Private Const SPI_SETMENUFADE = &H1013

Private Const HWND_BOTTOM = 1
Private Const HWND_BROADCAST = &HFFFF&
Private Const HWND_DESKTOP = 0&
Private Const HWND_TOP = -2
Private Const HWND_NOTOPMOST = 0&
Private Const HWND_TOPMOST = -1

Private Const SWP_NOSENDCHANGING = &H400
Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_HIDEWINDOW = &H80
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_NOCOPYBITS = &H100
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOOWNERZORDER = &H200
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_SHOWWINDOW = &H40
Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Private Const SWP_NOREPOSITION = SWP_NOOWNERZORDER

Private Const EM_CANUNDO = &HC6
Private Const EM_EMPTYUNDOBUFFER = &HCD
Private Const EM_FMTLINES = &HC8
Private Const EM_GETFIRSTVISIBLELINE = &HCE
Private Const EM_GETLINE = &HC4
Private Const EM_GETLINECOUNT = &HBA
Private Const EM_GETMODIFY = &HB8
Private Const EM_GETPASSWORDCHAR = &HD2
Private Const EM_GETRECT = &HB2
Private Const EM_GETSEL = &HB0
Private Const EM_GETTHUMB = &HBE
Private Const EM_GETWORDBREAKPROC = &HD1
Private Const EM_LIMITTEXT = &HC5
Private Const EM_LINEFROMCHAR = &HC9
Private Const EM_LINEINDEX = &HBB
Private Const EM_LINELENGTH = &HC1
Private Const EM_LINESCROLL = &HB6
Private Const EM_REPLACESEL = &HC2
Private Const EM_SCROLL = &HB5
Private Const EM_SCROLLCARET = &HB7
Private Const EM_SETHANDLE = &HBC
Private Const EM_SETMODIFY = &HB9
Private Const EM_SETPASSWORDCHAR = &HCC
Private Const EM_SETREADONLY = &HCF
Private Const EM_SETRECT = &HB3
Private Const EM_SETRECTNP = &HB4
Private Const EM_SETSEL = &HB1
Private Const EM_SETTABSTOPS = &HCB
Private Const EM_SETWORDBREAKPROC = &HD0
Private Const EM_UNDO = &HC7

Private Const EN_CHANGE = &H300
Private Const EN_ERRSPACE = &H500
Private Const EN_HSCROLL = &H601
Private Const EN_KILLFOCUS = &H200
Private Const EN_MAXTEXT = &H501
Private Const EN_SETFOCUS = &H100
Private Const EN_UPDATE = &H400
Private Const EN_VSCROLL = &H602

' BitBlt flags

Private Const MERGEPAINT = &HBB0226
Private Const SRCERASE = &H440328
Private Const SRCINVERT = &H660046
Private Const SRCPAINT = &HEE0086
Private Const SRCCOPY = &HCC0020
Private Const MERGECOPY = &HC000CA
Private Const NOTSRCCOPY = &H330008
Private Const NOTSRCERASE = &H1100A6


'' ROP2

Private Const R2_BLACK = 1
Private Const R2_COPYPEN = 13
Private Const R2_LAST = 16
Private Const R2_MASKNOTPEN = 3
Private Const R2_MASKPEN = 9
Private Const R2_MASKPENNOT = 5
Private Const R2_MERGENOTPEN = 12
Private Const R2_MERGEPEN = 15
Private Const R2_MERGEPENNOT = 14
Private Const R2_NOP = 11
Private Const R2_NOT = 6
Private Const R2_NOTCOPYPEN = 4
Private Const R2_NOTMASKPEN = 8
Private Const R2_NOTMERGEPEN = 2
Private Const R2_NOTXORPEN = 10
Private Const R2_WHITE = 16
Private Const R2_XORPEN = 7

''' Window movement / Window attributes

' Combobox Window Messages (including WM_MEASUREITEM and WM_DRAWITEM)

Private Const CB_ADDSTRING = &H143
Private Const CB_DELETESTRING = &H144
Private Const CB_DIR = &H145
Private Const CB_ERR = (-1)
Private Const CB_ERRSPACE = (-2)
Private Const CB_FINDSTRING = &H14C
Private Const CB_FINDSTRINGEXACT = &H158
Private Const CB_GETCOUNT = &H146
Private Const CB_GETCURSEL = &H147
Private Const CB_GETDROPPEDCONTROLRECT = &H152
Private Const CB_GETDROPPEDSTATE = &H157
Private Const CB_GETEDITSEL = &H140
Private Const CB_GETEXTENDEDUI = &H156
Private Const CB_GETITEMDATA = &H150
Private Const CB_GETITEMHEIGHT = &H154
Private Const CB_GETLBTEXT = &H148
Private Const CB_GETLBTEXTLEN = &H149
Private Const CB_GETLOCALE = &H15A
Private Const CB_INSERTSTRING = &H14A
Private Const CB_LIMITTEXT = &H141
Private Const CB_MSGMAX = &H15B
Private Const CB_OKAY = 0&
Private Const CB_RESETCONTENT = &H14B
Private Const CB_SELECTSTRING = &H14D
Private Const CB_SETCURSEL = &H14E
Private Const CB_SETEDITSEL = &H142
Private Const CB_SETEXTENDEDUI = &H155
Private Const CB_SETITEMDATA = &H151
Private Const CB_SETITEMHEIGHT = &H153
Private Const CB_SETLOCALE = &H159
Private Const CB_SHOWDROPDOWN = &H14F
Private Const CB_GETDROPPEDWIDTH = &H15F
Private Const CB_SETDROPPEDWIDTH = &H160
Private Const CB_GETTOPINDEX = &H15B
Private Const CB_SETTOPINDEX = &H15C

' Combo Box Notify Constants

Private Const CBN_CLOSEUP = 8
Private Const CBN_DBLCLK = 2
Private Const CBN_DROPDOWN = 7
Private Const CBN_EDITCHANGE = 5
Private Const CBN_EDITUPDATE = 6
Private Const CBN_ERRSPACE = (-1)
Private Const CBN_KILLFOCUS = 4
Private Const CBN_SELCHANGE = 1
Private Const CBN_SELENDCANCEL = 10
Private Const CBN_SELENDOK = 9
Private Const CBN_SETFOCUS = 3

' Combo Box Style Constants

Private Const CBS_AUTOHSCROLL = &H40&
Private Const CBS_DISABLENOSCROLL = &H800&
Private Const CBS_DROPDOWN = &H2&
Private Const CBS_DROPDOWNLIST = &H3&
Private Const CBS_HASSTRINGS = &H200&
Private Const CBS_NOINTEGRALHEIGHT = &H400&
Private Const CBS_OEMCONVERT = &H80&
Private Const CBS_OWNERDRAWFIXED = &H10&
Private Const CBS_OWNERDRAWVARIABLE = &H20&
Private Const CBS_SIMPLE = &H1&
Private Const CBS_SORT = &H100&

' List Box Commands / Constants

Private Const LB_ADDSTRING = &H180
Private Const LB_CTLCODE = 0&
Private Const LB_DELETESTRING = &H182
Private Const LB_DIR = &H18D
Private Const LB_ERR = (-1)
Private Const LB_ERRSPACE = (-2)
Private Const LB_FINDSTRING = &H18F
Private Const LB_FINDSTRINGEXACT = &H1A2
Private Const LB_GETANCHORINDEX = &H19D
Private Const LB_GETCARETINDEX = &H19F
Private Const LB_GETCOUNT = &H18B
Private Const LB_GETCURSEL = &H188
Private Const LB_GETHORIZONTALEXTENT = &H193
Private Const LB_GETITEMDATA = &H199
Private Const LB_GETITEMHEIGHT = &H1A1
Private Const LB_GETITEMRECT = &H198
Private Const LB_GETLOCALE = &H1A6
Private Const LB_GETSEL = &H187
Private Const LB_GETSELCOUNT = &H190
Private Const LB_GETSELITEMS = &H191
Private Const LB_GETTEXT = &H189
Private Const LB_GETTEXTLEN = &H18A
Private Const LB_GETTOPINDEX = &H18E
Private Const LB_INSERTSTRING = &H181
Private Const LB_MSGMAX = &H1A8
Private Const LB_OKAY = 0&
Private Const LB_RESETCONTENT = &H184
Private Const LB_SELECTSTRING = &H18C
Private Const LB_SELITEMRANGE = &H19B
Private Const LB_SELITEMRANGEEX = &H183
Private Const LB_SETANCHORINDEX = &H19C
Private Const LB_SETCARETINDEX = &H19E
Private Const LB_SETCOLUMNWIDTH = &H195
Private Const LB_SETCOUNT = &H1A7
Private Const LB_SETCURSEL = &H186
Private Const LB_SETHORIZONTALEXTENT = &H194
Private Const LB_SETITEMDATA = &H19A
Private Const LB_SETITEMHEIGHT = &H1A0
Private Const LB_SETLOCALE = &H1A5
Private Const LB_SETSEL = &H185
Private Const LB_SETTABSTOPS = &H192
Private Const LB_SETTOPINDEX = &H197

' List Box Messages

Private Const LBN_DBLCLK = 2
Private Const LBN_ERRSPACE = (-2)
Private Const LBN_KILLFOCUS = 5
Private Const LBN_SELCANCEL = 3
Private Const LBN_SELCHANGE = 1
Private Const LBN_SETFOCUS = 4

' List Box Styles

Private Const LBS_DISABLENOSCROLL = &H1000&
Private Const LBS_EXTENDEDSEL = &H800&
Private Const LBS_HASSTRINGS = &H40&
Private Const LBS_MULTICOLUMN = &H200&
Private Const LBS_MULTIPLESEL = &H8&
Private Const LBS_NODATA = &H2000&
Private Const LBS_NOINTEGRALHEIGHT = &H100&
Private Const LBS_NOREDRAW = &H4&
Private Const LBS_NOTIFY = &H1&
Private Const LBS_OWNERDRAWFIXED = &H10&
Private Const LBS_OWNERDRAWVARIABLE = &H20&
Private Const LBS_SORT = &H2&
Private Const LBS_STANDARD = (LBS_NOTIFY Or LBS_SORT Or WS_VSCROLL Or WS_BORDER)
Private Const LBS_USETABSTOPS = &H80&
Private Const LBS_WANTKEYBOARDINPUT = &H400&

'' Edit Styles

Private Const ES_AUTOHSCROLL = &H80&
Private Const ES_AUTOVSCROLL = &H40&
Private Const ES_CENTER = &H1&
Private Const ES_LEFT = &H0&
Private Const ES_LOWERCASE = &H10&
Private Const ES_MULTILINE = &H4&
Private Const ES_NOHIDESEL = &H100&
Private Const ES_OEMCONVERT = &H400&
Private Const ES_PASSWORD = &H20&
Private Const ES_READONLY = &H800&
Private Const ES_RIGHT = &H2&
Private Const ES_UPPERCASE = &H8&
Private Const ES_WANTRETURN = &H1000&

Private Const ES_STD = (ES_AUTOHSCROLL + ES_LEFT)
Private Const ES_MULTI_STD = (ES_AUTOHSCROLL + ES_LEFT + ES_MULTILINE + ES_WANTRETURN) + WS_VSCROLL

'' Button Styles

Private Const BS_PUSHBUTTON = &H0
Private Const BS_DEFPUSHBUTTON = &H1
Private Const BS_CHECKBOX = &H2
Private Const BS_AUTOCHECKBOX = &H3
Private Const BS_RADIOBUTTON = &H4
Private Const BS_3STATE = &H5
Private Const BS_AUTO3STATE = &H6
Private Const BS_GROUPBOX = &H7
Private Const BS_USERBUTTON = &H8
Private Const BS_AUTORADIOBUTTON = &H9
Private Const BS_OWNERDRAW = &HB
Private Const BS_LEFTTEXT = &H20
'' (WINVER >= =&H0400)
Private Const BS_TEXT = &H0
Private Const BS_ICON = &H40
Private Const BS_BITMAP = &H80
Private Const BS_LEFT = &H100
Private Const BS_RIGHT = &H200
Private Const BS_CENTER = &H300
Private Const BS_TOP = &H400
Private Const BS_BOTTOM = &H800
Private Const BS_VCENTER = &HC00
Private Const BS_PUSHLIKE = &H1000
Private Const BS_MULTILINE = &H2000
Private Const BS_NOTIFY = &H4000
Private Const BS_FLAT = &H8000
Private Const BS_RIGHTBUTTON = BS_LEFTTEXT
'' (End) '' WINVER >= =&H0400 ''

''
 '' User Button Notification Codes
 ''
Private Const BN_CLICKED = 0
Private Const BN_PAINT = 1
Private Const BN_HILITE = 2
Private Const BN_UNHILITE = 3
Private Const BN_DISABLE = 4
Private Const BN_DOUBLECLICKED = 5
'' (WINVER >= =&H0400)
Private Const BN_PUSHED = BN_HILITE
Private Const BN_UNPUSHED = BN_UNHILITE
Private Const BN_DBLCLK = BN_DOUBLECLICKED
Private Const BN_SETFOCUS = 6
Private Const BN_KILLFOCUS = 7
'' (End) '' WINVER >= =&H0400 ''

''
 '' Button Control Messages
 ''
Private Const BM_GETCHECK = &HF0
Private Const BM_SETCHECK = &HF1
Private Const BM_GETSTATE = &HF2
Private Const BM_SETSTATE = &HF3
Private Const BM_SETSTYLE = &HF4
'' (WINVER >= =&H0400)
Private Const BM_CLICK = &HF5
Private Const BM_GETIMAGE = &HF6
Private Const BM_SETIMAGE = &HF7

Private Const BST_UNCHECKED = &H0
Private Const BST_CHECKED = &H1
Private Const BST_INDETERMINATE = &H2
Private Const BST_PUSHED = &H4
Private Const BST_FOCUS = &H8
'' (End) '' WINVER >= =&H0400 ''

''
 '' Static Control Constants
 ''
Private Const SS_LEFT = &H0
Private Const SS_CENTER = &H1
Private Const SS_RIGHT = &H2
Private Const SS_ICON = &H3
Private Const SS_BLACKRECT = &H4
Private Const SS_GRAYRECT = &H5
Private Const SS_WHITERECT = &H6
Private Const SS_BLACKFRAME = &H7
Private Const SS_GRAYFRAME = &H8
Private Const SS_WHITEFRAME = &H9
Private Const SS_USERITEM = &HA
Private Const SS_SIMPLE = &HB
Private Const SS_LEFTNOWORDWRAP = &HC
'' (WINVER >= =&H0400)
Private Const SS_OWNERDRAW = &HD
Private Const SS_BITMAP = &HE
Private Const SS_ENHMETAFILE = &HF
Private Const SS_ETCHEDHORZ = &H10
Private Const SS_ETCHEDVERT = &H11
Private Const SS_ETCHEDFRAME = &H12
Private Const SS_TYPEMASK = &H1F
'' (End) '' WINVER >= =&H0400 ''
Private Const SS_NOPREFIX = &H80              '' Don't do "&" character translation ''
'' (WINVER >= =&H0400)
Private Const SS_NOTIFY = &H100
Private Const SS_CENTERIMAGE = &H200
Private Const SS_RIGHTJUST = &H400
Private Const SS_REALSIZEIMAGE = &H800
Private Const SS_SUNKEN = &H1000
Private Const SS_ENDELLIPSIS = &H4000
Private Const SS_PATHELLIPSIS = &H8000
Private Const SS_WORDELLIPSIS = &HC000
Private Const SS_ELLIPSISMASK = &HC000
'' (End) '' WINVER >= =&H0400 ''



'' ndef NOWINMESSAGES
''
 '' Static Control Mesages
 ''
Private Const STM_SETICON = &H170
Private Const STM_GETICON = &H171
'' (WINVER >= =&H0400)
Private Const STM_SETIMAGE = &H172
Private Const STM_GETIMAGE = &H173
Private Const STN_CLICKED = 0
Private Const STN_DBLCLK = 1
Private Const STN_ENABLE = 2
Private Const STN_DISABLE = 3
'' (End) '' WINVER >= =&H0400 ''
Private Const STM_MSGMAX = &H174



'' Frame Control

Private Const DFC_BUTTON = 4
Private Const DFC_CAPTION = 1
Private Const DFC_MENU = 2
Private Const DFC_SCROLL = 3

Private Const DFCS_ADJUSTRECT = &H2000
Private Const DFCS_BUTTON3STATE = &H8
Private Const DFCS_BUTTONCHECK = &H0
Private Const DFCS_BUTTONPUSH = &H10
Private Const DFCS_BUTTONRADIO = &H4
Private Const DFCS_BUTTONRADIOIMAGE = &H1
Private Const DFCS_BUTTONRADIOMASK = &H2
Private Const DFCS_CAPTIONCLOSE = &H0
Private Const DFCS_CAPTIONHELP = &H4
Private Const DFCS_CAPTIONMAX = &H2
Private Const DFCS_CAPTIONMIN = &H1
Private Const DFCS_CAPTIONRESTORE = &H3
Private Const DFCS_CHECKED = &H400
Private Const DFCS_FLAT = &H4000
Private Const DFCS_INACTIVE = &H100
Private Const DFCS_MENUARROW = &H0
Private Const DFCS_MENUARROWRIGHT = &H4
Private Const DFCS_MENUBULLET = &H2
Private Const DFCS_MENUCHECK = &H1
Private Const DFCS_MONO = &H8000
Private Const DFCS_PUSHED = &H200
Private Const DFCS_SCROLLCOMBOBOX = &H5
Private Const DFCS_SCROLLDOWN = &H1
Private Const DFCS_SCROLLLEFT = &H2
Private Const DFCS_SCROLLRIGHT = &H3
Private Const DFCS_SCROLLSIZEGRIP = &H8
Private Const DFCS_SCROLLSIZEGRIPRIGHT = &H10
Private Const DFCS_SCROLLUP = &H0

Private Const SW_ERASE = &H4
Private Const SW_HIDE = 0&
Private Const SW_INVALIDATE = &H2
Private Const SW_MAX = 10
Private Const SW_MAXIMIZE = 3
Private Const SW_MINIMIZE = 6
Private Const SW_NORMAL = 1
Private Const SW_OTHERUNZOOM = 4
Private Const SW_OTHERZOOM = 2
Private Const SW_PARENTCLOSING = 1
Private Const SW_PARENTOPENING = 3
Private Const SW_RESTORE = 9
Private Const SW_SCROLLCHILDREN = &H1
Private Const SW_SHOW = 5
Private Const SW_SHOWDEFAULT = 10
Private Const SW_SHOWMAXIMIZED = 3
Private Const SW_SHOWMINIMIZED = 2
Private Const SW_SHOWMINNOACTIVE = 7
Private Const SW_SHOWNA = 8
Private Const SW_SHOWNOACTIVATE = 4
Private Const SW_SHOWNORMAL = 1

'' System Cursors

Private Const IDC_ARROW = (32512&)
Private Const IDC_IBEAM = (32513&)
Private Const IDC_WAIT = (32514&)
Private Const IDC_CROSS = (32515&)
Private Const IDC_UPARROW = (32516&)
Private Const IDC_SIZE = (32640&)            '' OBSOLETE: use IDC_SIZEALL ''
Private Const IDC_ICON = (32641&)            '' OBSOLETE: use IDC_ARROW ''
Private Const IDC_SIZENWSE = (32642&)
Private Const IDC_SIZENESW = (32643&)
Private Const IDC_SIZEWE = (32644&)
Private Const IDC_SIZENS = (32645&)
Private Const IDC_SIZEALL = (32646&)
Private Const IDC_NO = (32648&)             ''not in win3.1 ''
Private Const IDC_HAND = (32649&)
Private Const IDC_APPSTARTING = (32650&)    ''not in win3.1 ''
Private Const IDC_HELP = (32651&)


' Window Messages

Private Const HTBORDER = 18
Private Const HTBOTTOM = 15
Private Const HTBOTTOMLEFT = 16
Private Const HTBOTTOMRIGHT = 17
Private Const HTCAPTION = 2
Private Const HTCLIENT = 1
Private Const HTERROR = (-2)
Private Const HTGROWBOX = 4
Private Const HTHSCROLL = 6
Private Const HTLEFT = 10
Private Const HTMAXBUTTON = 9
Private Const HTMENU = 5
Private Const HTMINBUTTON = 8
Private Const HTNOWHERE = 0&


Private Const WM_ENTERSIZEMOVE = &H231
Private Const WM_EXITSIZEMOVE = &H232

Private Const WM_ERASEBKGND = &H14

Private Const WM_DRAWITEM = &H2B
Private Const WM_MEASUREITEM = &H2C
Private Const WM_COMPAREITEM = &H39
Private Const WM_COMMAND = &H111
Private Const WM_MENUCHAR = &H120
Private Const WM_MENUSELECT = &H11F

Private Const WM_INITMENU = &H116
Private Const WM_INITMENUPOPUP = &H117

Private Const WM_MENURBUTTONUP = &H122
Private Const WM_MENUDRAG = &H123
Private Const WM_MENUGETOBJECT = &H124
Private Const WM_UNINITMENUPOPUP = &H125
Private Const WM_MENUCOMMAND = &H126

Private Const WM_USER = &H400
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_MOUSEMOVE = &H200
Private Const WM_MBUTTONUP = &H208
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONDBLCLK = &H209
Private Const WM_LBUTTONUP = &H202
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_MOUSEWHEEL = &H20A
Private Const WM_CONTEXTMENU = &H7B
Private Const WM_TIMER = &H113
Private Const WM_SYSCHAR = &H106
Private Const WM_SYSKEYDOWN = &H104
Private Const WM_SYSKEYUP = &H105
Private Const WM_SYSCOMMAND = &H112
Private Const WM_KEYUP = &H101
Private Const WM_KEYLAST = &H108
Private Const WM_KEYDOWN = &H100
Private Const WM_KEYFIRST = &H100
Private Const WM_ACTIVATE = &H6
Private Const WM_SETTEXT = &HC
Private Const WM_MOVE = &H3
Private Const WM_PAINT = &HF
Private Const WM_SETREDRAW = &HB
Private Const WM_GETTEXT = &HD
Private Const WM_GETTEXTLENGTH = &HE
Private Const WM_SETFONT = &H30
Private Const WM_DESTROY = &H2
Private Const WM_SETFOCUS = &H7
Private Const WM_SETCURSOR = &H20
Private Const WM_ENABLE = &HA
Private Const WM_SHOWWINDOW = &H18
Private Const WM_SIZE = &H5
Private Const WM_CHAR = &H102
Private Const WM_KILLFOCUS = &H8
Private Const WM_VSCROLL = &H115
Private Const WM_HSCROLL = &H114

Private Const WM_SIZING = &H214
Private Const WM_CAPTURECHANGED = &H215
Private Const WM_MOVING = &H216
Private Const WM_NEXTMENU = &H213

Private Const MK_LBUTTON = &H1
Private Const MK_RBUTTON = &H2
Private Const MK_MBUTTON = &H10
Private Const MK_SHIFT = &H4
Private Const MK_CONTROL = &H8

Private Const WM_COPY = &H301
Private Const WM_COPYDATA = &H4A
Private Const WM_CUT = &H300
Private Const WM_PASTE = &H302

' Multiple Document Interface Window Messages

Private Const WM_MDIACTIVATE = &H222
Private Const WM_MDICASCADE = &H227
Private Const WM_MDICREATE = &H220
Private Const WM_MDIDESTROY = &H221
Private Const WM_MDIGETACTIVE = &H229
Private Const WM_MDIICONARRANGE = &H228
Private Const WM_MDIMAXIMIZE = &H225
Private Const WM_MDINEXT = &H224
Private Const WM_MDIREFRESHMENU = &H234
Private Const WM_MDIRESTORE = &H223
Private Const WM_MDISETMENU = &H230
Private Const WM_MDITILE = &H226

' Non-client area painting

Private Const WM_NCPAINT = &H85
Private Const WM_NCMOUSEMOVE = &HA0
Private Const WM_NCMBUTTONUP = &HA8
Private Const WM_NCMBUTTONDOWN = &HA7
Private Const WM_NCMBUTTONDBLCLK = &HA9
Private Const WM_NCLBUTTONUP = &HA2
Private Const WM_NCLBUTTONDOWN = &HA1
Private Const WM_NCLBUTTONDBLCLK = &HA3
Private Const WM_NCHITTEST = &H84
Private Const WM_NCDESTROY = &H82
Private Const WM_NCCREATE = &H81
Private Const WM_NCCALCSIZE = &H83
Private Const WM_NCACTIVATE = &H86
Private Const WM_NCRBUTTONDBLCLK = &HA6
Private Const WM_NCRBUTTONDOWN = &HA4
Private Const WM_NCRBUTTONUP = &HA5
Private Const WM_IME_CHAR = &H286
Private Const WM_IME_COMPOSITION = &H10F
Private Const WM_IME_COMPOSITIONFULL = &H284
Private Const WM_IME_CONTROL = &H283
Private Const WM_IME_ENDCOMPOSITION = &H10E
Private Const WM_IME_KEYDOWN = &H290
Private Const WM_IME_KEYLAST = &H10F
Private Const WM_IME_KEYUP = &H291
Private Const WM_IME_NOTIFY = &H282
Private Const WM_IME_SELECT = &H285
Private Const WM_IME_SETCONTEXT = &H281
Private Const WM_IME_STARTCOMPOSITION = &H10D

Private Const GWL_WNDPROC = (-4)
Private Const GWL_STYLE = (-16)
Private Const GWL_EXSTYLE = (-20)

Private Const IMAGE_BITMAP = 0&
Private Const IMAGE_ICON = 1
Private Const IMAGE_CURSOR = 2
Private Const IMAGE_ENHMETAFILE = 3

Private Const RDW_ALLCHILDREN = &H80
Private Const RDW_ERASE = &H4
Private Const RDW_ERASENOW = &H200
Private Const RDW_FRAME = &H400
Private Const RDW_INTERNALPAINT = &H2
Private Const RDW_INVALIDATE = &H1
Private Const RDW_NOCHILDREN = &H40
Private Const RDW_NOERASE = &H20
Private Const RDW_NOFRAME = &H800
Private Const RDW_NOINTERNALPAINT = &H10
Private Const RDW_UPDATENOW = &H100
Private Const RDW_VALIDATE = &H8

' GetCharacterPlacement Constant Values

Private Const GCP_CLASSIN = &H80000
Private Const GCP_DBCS = &H1&
Private Const GCP_DIACRITIC = &H100&
Private Const GCP_DISPLAYZWG = &H400000
Private Const GCP_ERROR = &H8000&
Private Const GCP_GLYPHSHAPE = &H10&
Private Const GCP_JUSTIFY = &H10000
Private Const GCP_JUSTIFYIN = &H200000
Private Const GCP_KASHIDA = &H400&
Private Const GCP_LIGATE = &H20&
Private Const GCP_MAXEXTENT = &H100000
Private Const GCP_NEUTRALOVERRIDE = &H2000000
Private Const GCP_NODIACRITICS = &H20000
Private Const GCP_NUMERICOVERRIDE = &H1000000
Private Const GCP_NUMERICSLATIN = &H4000000
Private Const GCP_NUMERICSLOCAL = &H8000000
Private Const GCP_REORDER = &H2&
Private Const GCP_SYMSWAPOFF = &H800000
Private Const GCP_USEKERNING = &H8&

' GetCharacterPlacement Class Monikers

Private Const GCPCLASS_ARABIC = 2
Private Const GCPCLASS_HEBREW = 2
Private Const GCPCLASS_LATIN = 1
Private Const GCPCLASS_LATINNUMBER = 5
Private Const GCPCLASS_LATINNUMERICSEPARATOR = 7
Private Const GCPCLASS_LATINNUMERICTERMINATOR = 6
Private Const GCPCLASS_LOCALNUMBER = 4
Private Const GCPCLASS_NEUTRAL = 3
Private Const GCPCLASS_NUMERICSEPARATOR = 8
Private Const GCPCLASS_PREBOUNDLTR = &H40
Private Const GCPCLASS_PREBOUNDRTL = &H80


Private Const ETO_OPAQUE = &H2
Private Const ETO_CLIPPED = &H4

' If (WINVER >= =&H0400)
Private Const ETO_GLYPH_INDEX = &H10
Private Const ETO_RTLREADING = &H80
Private Const ETO_NUMERICSLOCAL = &H400
Private Const ETO_NUMERICSLATIN = &H800
Private Const ETO_IGNORELANGUAGE = &H1000
' ' WINVER >= =&H0400

' If  (_WIN32_WINNT >= =&H0500) (Windows 2000)
Private Const ETO_PDY = &H2000
' ' (_WIN32_WINNT >= =&H0500)

Private Const FLI_GLYPHS = &H40000
Private Const FLI_MASK = &H103B

'' Scroll Bar Types

Private Const SB_BOTH = 3
Private Const SB_BOTTOM = 7
Private Const SB_CTL = 2
Private Const SB_ENDSCROLL = 8
Private Const SB_HORZ = 0&
Private Const SB_LEFT = 6
Private Const SB_LINEDOWN = 1
Private Const SB_LINELEFT = 0&
Private Const SB_LINERIGHT = 1
Private Const SB_LINEUP = 0&
Private Const SB_PAGEDOWN = 3
Private Const SB_PAGELEFT = 2
Private Const SB_PAGERIGHT = 3
Private Const SB_PAGEUP = 2
Private Const SB_RIGHT = 7
Private Const SB_THUMBPOSITION = 4
Private Const SB_THUMBTRACK = 5
Private Const SB_TOP = 6
Private Const SB_VERT = 1

'' Scroll Bar Messages

Private Const SBM_ENABLE_ARROWS = &HE4
Private Const SBM_GETPOS = &HE1
Private Const SBM_GETRANGE = &HE3
Private Const SBM_SETPOS = &HE0
Private Const SBM_SETRANGE = &HE2
Private Const SBM_SETRANGEREDRAW = &HE6

'' Scroll Bar Window Styles

Private Const SBS_BOTTOMALIGN = &H4&
Private Const SBS_HORZ = &H0&
Private Const SBS_LEFTALIGN = &H2&
Private Const SBS_RIGHTALIGN = &H4&
Private Const SBS_SIZEBOX = &H8&
Private Const SBS_SIZEBOXBOTTOMRIGHTALIGN = &H4&
Private Const SBS_SIZEBOXTOPLEFTALIGN = &H2&
Private Const SBS_TOPALIGN = &H2&
Private Const SBS_VERT = &H1&

'' EnableScrollBar() flags

Private Const ESB_DISABLE_BOTH = &H3
Private Const ESB_DISABLE_DOWN = &H2
Private Const ESB_DISABLE_LEFT = &H1
Private Const ESB_DISABLE_RIGHT = &H2
Private Const ESB_DISABLE_UP = &H1

Private Const ESB_DISABLE_RTDN = ESB_DISABLE_RIGHT
Private Const ESB_DISABLE_LTUP = ESB_DISABLE_LEFT

Private Const ESB_ENABLE_BOTH = &H0

Private Const DI_MASK = &H1
Private Const DI_IMAGE = &H2
Private Const DI_NORMAL = &H3
Private Const DI_COMPAT = &H4
Private Const DI_DEFAULTSIZE = &H8

Private Const MNC_IGNORE = 0&
Private Const MNC_CLOSE = (1 * &H10000)
Private Const MNC_EXECUTE = (2 * &H10000)
Private Const MNC_SELECT = (3 * &H10000)

Private Const FALT = &H10
Private Const FCONTROL = &H8
Private Const FNOINVERT = &H2
Private Const FSHIFT = &H4

Private Const NIF_CUSTOM_MSG = (WM_USER + &H108)

Private Const STRETCH_HALFTONE = 4
Private Const STRETCH_DELETESCANS = 3
Private Const STRETCH_ORSCANS = 2
Private Const STRETCHBLTC = 2048

' fMask flags

Private Const MIIM_STATE = &H1
Private Const MIIM_ID = &H2
Private Const MIIM_SUBMENU = &H4
Private Const MIIM_CHECKMARKS = &H8
Private Const MIIM_TYPE = &H10
Private Const MIIM_DATA = &H20

'' New for Windows 98/2000

Private Const MIIM_STRING = &H40
Private Const MIIM_BITMAP = &H80
Private Const MIIM_FTYPE = &H100

'' End fMask flags

' Menu Flags

Private Const MF_INSERT = &H0&
Private Const MF_CHANGE = &H80&
Private Const MF_APPEND = &H100&
Private Const MF_DELETE = &H200&
Private Const MF_REMOVE = &H1000&

Private Const MF_BYCOMMAND = &H0&
Private Const MF_BYPOSITION = &H400&

Private Const MF_SEPARATOR = &H800&

Private Const MF_ENABLED = &H0&
Private Const MF_GRAYED = &H1&
Private Const MF_DISABLED = &H2&

Private Const MF_UNCHECKED = &H0&
Private Const MF_CHECKED = &H8&
Private Const MF_USECHECKBITMAPS = &H200&

Private Const MF_STRING = &H0&
Private Const MF_BITMAP = &H4&
Private Const MF_OWNERDRAW = &H100&

Private Const MF_POPUP = &H10&
Private Const MF_MENUBARBREAK = &H20&
Private Const MF_MENUBREAK = &H40&

Private Const MF_UNHILITE = &H0&
Private Const MF_HILITE = &H80&

Private Const MF_DEFAULT = &H1000&
Private Const MF_SYSMENU = &H2000&
Private Const MF_HELP = &H4000&
Private Const MF_RIGHTJUSTIFY = &H4000&

Private Const MF_MOUSESELECT = &H8000&
Private Const MF_END = &H80&                    ' Obsolete -- only used by old RES files


Private Const MFT_STRING = MF_STRING
Private Const MFT_BITMAP = MF_BITMAP
Private Const MFT_MENUBARBREAK = MF_MENUBARBREAK
Private Const MFT_MENUBREAK = MF_MENUBREAK
Private Const MFT_OWNERDRAW = MF_OWNERDRAW
Private Const MFT_RADIOGROUP = &H200&
Private Const MFT_SEPARATOR = MF_SEPARATOR
Private Const MFT_RIGHTORDER = &H2000&
Private Const MFT_RIGHTJUSTIFY = MF_RIGHTJUSTIFY

Private Const MFS_GRAYED = &H3&
Private Const MFS_DISABLED = MFS_GRAYED
Private Const MFS_CHECKED = MF_CHECKED
Private Const MFS_HILITE = MF_HILITE
Private Const MFS_ENABLED = MF_ENABLED
Private Const MFS_UNCHECKED = MF_UNCHECKED
Private Const MFS_UNHILITE = MF_UNHILITE
Private Const MFS_DEFAULT = MF_DEFAULT

' New for Windows 2000/98

Private Const MFS_MASK = &H108B&
Private Const MFS_HOTTRACKDRAWN = &H10000000
Private Const MFS_CACHEDBMP = &H20000000
Private Const MFS_BOTTOMGAPDROP = &H40000000
Private Const MFS_TOPGAPDROP = &H80000000
Private Const MFS_GAPDROP = &HC0000000

' for the SetMenuInfo API function

Private Const MNS_NOCHECK = &H80000000
Private Const MNS_MODELESS = &H40000000
Private Const MNS_DRAGDROP = &H20000000
Private Const MNS_AUTODISMISS = &H10000000
Private Const MNS_NOTIFYBYPOS = &H8000000
Private Const MNS_CHECKORBMP = &H4000000

Private Const MIM_MAXHEIGHT = &H1
Private Const MIM_BACKGROUND = &H2
Private Const MIM_HELPID = &H4
Private Const MIM_MENUDATA = &H8
Private Const MIM_STYLE = &H10
Private Const MIM_APPLYTOSUBMENUS = &H80000000


'' System Object Identifier Constants

Private Const OBJID_WINDOW = &H0&
Private Const OBJID_SYSMENU = &HFFFFFFFF
Private Const OBJID_TITLEBAR = &HFFFFFFFE
Private Const OBJID_MENU = &HFFFFFFFD
Private Const OBJID_CLIENT = &HFFFFFFFC
Private Const OBJID_VSCROLL = &HFFFFFFFB
Private Const OBJID_HSCROLL = &HFFFFFFFA
Private Const OBJID_SIZEGRIP = &HFFFFFFF9
Private Const OBJID_CARET = &HFFFFFFF8
Private Const OBJID_CURSOR = &HFFFFFFF7
Private Const OBJID_ALERT = &HFFFFFFF6
Private Const OBJID_SOUND = &HFFFFFFF5
Private Const OBJID_QUERYCLASSNAMEIDX = &HFFFFFFF4
Private Const OBJID_NATIVEOM = &HFFFFFFF0

'' Global Memory Constants

Private Const GMEM_DDESHARE = &H2000
Private Const GMEM_DISCARDABLE = &H100
Private Const GMEM_DISCARDED = &H4000
Private Const GMEM_FIXED = &H0
Private Const GMEM_INVALID_HANDLE = &H8000
Private Const GMEM_LOCKCOUNT = &HFF
Private Const GMEM_MODIFY = &H80
Private Const GMEM_MOVEABLE = &H2
Private Const GMEM_NOCOMPACT = &H10
Private Const GMEM_NODISCARD = &H20
Private Const GMEM_NOT_BANKED = &H1000
Private Const GMEM_NOTIFY = &H4000
Private Const GMEM_SHARE = &H2000
Private Const GMEM_VALID_FLAGS = &H7F72
Private Const GMEM_ZEROINIT = &H40

Private Const GMEM_LOWER = GMEM_NOT_BANKED


'' National Language / IME Support Functions

Private Const CP_ACP = 0&
Private Const CP_NONE = 0&
Private Const CP_OEMCP = 1
Private Const CP_RECTANGLE = 1
Private Const CP_REGION = 2
Private Const CP_WINANSI = 1004
Private Const CP_WINUNICODE = 1200

Private Const ANSI_CHARSET = 0&
Private Const DEFAULT_CHARSET = 1
Private Const SYMBOL_CHARSET = 2
Private Const SHIFTJIS_CHARSET = 128
Private Const HANGEUL_CHARSET = 129
Private Const HANGUL_CHARSET = 129
Private Const GB2312_CHARSET = 134
Private Const CHINESEBIG5_CHARSET = 136
Private Const OEM_CHARSET = 255
Private Const JOHAB_CHARSET = 130
Private Const HEBREW_CHARSET = 177
Private Const ARABIC_CHARSET = 178
Private Const GREEK_CHARSET = 161
Private Const TURKISH_CHARSET = 162
Private Const VIETNAMESE_CHARSET = 163
Private Const THAI_CHARSET = 222
Private Const EASTEUROPE_CHARSET = 238
Private Const RUSSIAN_CHARSET = 204

Private Const MAC_CHARSET = 77
Private Const BALTIC_CHARSET = 186

Private Const FS_LATIN1 = &H1&
Private Const FS_LATIN2 = &H2&
Private Const FS_CYRILLIC = &H4&
Private Const FS_GREEK = &H8&
Private Const FS_TURKISH = &H10&
Private Const FS_HEBREW = &H20&
Private Const FS_ARABIC = &H40&
Private Const FS_BALTIC = &H80&
Private Const FS_VIETNAMESE = &H100&
Private Const FS_THAI = &H10000
Private Const FS_JISJAPAN = &H20000
Private Const FS_CHINESESIMP = &H40000
Private Const FS_WANSUNG = &H80000
Private Const FS_CHINESETRAD = &H100000
Private Const FS_JOHAB = &H200000
Private Const FS_SYMBOL = &H80000000



''' Shell_NotifyIcon Constants

' Shell_NotifyIcon features for Windows NT 5.0& (Windows 2000)

Private Const NIN_SELECT = (WM_USER + 0&)
Private Const NINF_KEY = &H1
Private Const NIN_KEYSELECT = (NIN_SELECT + NINF_KEY)
Private Const NIM_SETFOCUS = &H3
Private Const NIM_SETVERSION = &H4
Private Const NOTIFYICON_VERSION = 3
Private Const NIF_STATE = &H8
Private Const NIF_INFO = &H10

Private Const NIS_HIDDEN = &H1
Private Const NIS_SHAREDICON = &H2

' Regular NotifyIcon Features for Windows 95/98/NT

Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2

Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

' Notify Icon Infotip flags

Private Const NIIF_NONE = &H0

' icon flags are mutually exclusive
' and take only the lowest 2 bits

' Notify Icon Balloon Icon constants

Private Const NIIF_INFO = &H1
Private Const NIIF_WARNING = &H2
Private Const NIIF_ERROR = &H3

Private Const LR_DEFAULTCOLOR = &H0
Private Const LR_MONOCHROME = &H1
Private Const LR_COLOR = &H2
Private Const LR_COPYRETURNORG = &H4
Private Const LR_COPYDELETEORG = &H8
Private Const LR_LOADFROMFILE = &H10
Private Const LR_LOADTRANSPARENT = &H20
Private Const LR_DEFAULTSIZE = &H40
Private Const LR_VGACOLOR = &H80
Private Const LR_LOADMAP3DCOLORS = &H1000
Private Const LR_CREATEDIBSECTION = &H2000
Private Const LR_COPYFROMRESOURCE = &H4000
Private Const LR_SHARED = &H8000


Private Const SIF_RANGE = &H1
Private Const SIF_PAGE = &H2
Private Const SIF_POS = &H4
Private Const SIF_DISABLENOSCROLL = &H8
Private Const SIF_TRACKPOS = &H10
Private Const SIF_ALL = (SIF_RANGE + SIF_PAGE + SIF_POS + SIF_TRACKPOS)

'' Virtual Memory decommittal constants

Private Const MEM_DECOMMIT = &H4000
Private Const MEM_RELEASE = &H8000
Private Const MEM_FREE = &H10000


'' ****** TYPES ******


Private Type POINTAPI
        x As Long
        y As Long
End Type


'' Declared private in Designer as ITEMRECT

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type SIZEAPI
        cx As Long
        cy As Long
End Type

Private Type DIMAPI
    Left As Long
    Top As Long
    Width As Long
    Height As Long
End Type

''' CreateBrushIndirect Brush structure

Private Type LOGBRUSH
        lbStyle As Long
        lbColor As Long
        lbHatch As Long
End Type

''' CreatePenIndirect Pen structure

Private Type LOGPEN
        lopnStyle As Long
        lopnWidth As POINTAPI
        lopnColor As Long
End Type

''' CreateFontIndirect

Private Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(1 To LF_FACESIZE) As Byte
End Type

Private Type ENUMLOGFONTEX
        elfLogFont As LOGFONT
        elfFullName(1 To LF_FULLFACESIZE) As Byte
        elfStyle(1 To LF_FACESIZE) As Byte
        elfScript(1 To LF_FACESIZE) As Byte
End Type


Private Type CREATESTRUCT
        lpCreateParams As Long
        hInstance As Long
        hMenu As Long
        hWndParent As Long
        cy As Long
        cx As Long
        y As Long
        x As Long
        Style As Long
        lpszName As String
        lpszClass As String
        ExStyle As Long
End Type

Private Type CREATESTRUCT2
        lpCreateParams As Long
        hInstance As Long
        hMenu As Long
        hWndParent As Long
        cy As Long
        cx As Long
        y As Long
        x As Long
        Style As Long
        lpszName As String
        lpszClass As Long
        ExStyle As Long
End Type

Private Type MDICREATESTRUCT
        szClass As String
        szTitle As String
        hOwner As Long
        x As Long
        y As Long
        cx As Long
        cy As Long
        Style As Long
        lParam As Long
End Type

Private Type WINDOWPLACEMENT
        Length As Long
        Flags As Long
        showCmd As Long
        ptMinPosition As POINTAPI
        ptMaxPosition As POINTAPI
        rcNormalPosition As RECT
End Type

''' Structure for the WM_COMPAREITEM message

Private Type COMPAREITEMSTRUCT
        CtlType As Long
        CtlID As Long
        hwndItem As Long
        itemID1 As Long
        itemData1 As Long
        itemID2 As Long
        itemData2 As Long
End Type

''' Structure for the WM_DRAWITEM message

Private Type DRAWITEMSTRUCT
        CtlType As Long
        CtlID As Long
        ItemId As Long
        itemAction As Long
        itemState As Long
        hwndItem As Long
        hdc As Long
        rcItem As RECT
        itemData As Long
End Type

''' Structure for the WM_MEASUREITEMSTRUCT

Private Type MEASUREITEMSTRUCT
        CtlType As Long
        CtlID As Long
        ItemId As Long
        itemWidth As Long
        itemHeight As Long
        itemData As Long
End Type

''' GetCharacterPlacement Results

Private Type GCP_RESULTS
        lStructSize As Long
        lpOutString As Long
        lpOrder As Long
        lpDx As Long
        lpCaretPos As Long
        lpClass As Long
        lpGlyphs As Long
        nGlyphs As Long
        nMaxFit As Long
End Type

''' Measuring and Enumerating

Private Type TEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
End Type

Private Type NEWTEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
        ntmFlags As Long
        ntmSizeEM As Long
        ntmCellHeight As Long
        ntmAveWidth As Long
End Type

Private Type FONTSIGNATURE
        fsUsb(4) As Long
        fsCsb(2) As Long
End Type

Private Type NEWTEXTMETRICEX
        ntmTm As NEWTEXTMETRIC
        ntmFontSig As FONTSIGNATURE
End Type

''' Vertex

Private Type TRIVERTEX
    x As Long
    y As Long
    Red As Integer
    Green As Integer
    Blue As Integer
    Alpha As Integer
End Type

''' Gradient Rectangle

Private Type GRADIENT_RECT
    UpperLeft As Long
    LowerRight As Long
End Type


'' UUID structure

Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0& To 7) As Byte
End Type
        
''' Used by OleCreateFontIndirect
        
Private Type FONTDESC

    cbSize As Long
    
    szName As Long
    cySize As Long
    
    sWeight As Integer
    sCharset As Integer
    
    fItalic As Long
    fUnderline As Long
    fStrikethrough As Long
    
End Type


Private Type PICTDESCBMP
    SizeofStruct As Long
    PicType As Long
    hBitmap As Long
    hPalette As Long
End Type

Private Type PICTDESCICON
    SizeofStruct As Long
    PicType As Long
    hIcon As Long
    lReserved As Long
End Type


Private Type PALETTEENTRY
    Red As Byte
    Green As Byte
    Blue As Byte
    Flags As Byte
End Type

''' Used by SystemParametersInfo

Private Type NONCLIENTMETRICS
        cbSize As Long
        iBorderWidth As Long
        iScrollWidth As Long
        iScrollHeight As Long
        iCaptionWidth As Long
        iCaptionHeight As Long
        lfCaptionFont As LOGFONT
        iSMCaptionWidth As Long
        iSMCaptionHeight As Long
        lfSMCaptionFont As LOGFONT
        iMenuWidth As Long
        iMenuHeight As Long
        lfMenuFont As LOGFONT
        lfStatusFont As LOGFONT
        lfMessageFont As LOGFONT
End Type

Private Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Private Type RGBTRIPLE
        rgbtBlue As Byte
        rgbtGreen As Byte
        rgbtRed As Byte
End Type

Private Type BITMAPINFOHEADER
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Private Type BITMAPV4HEADER
        bV4Size As Long
        bV4Width As Long
        bV4Height As Long
        bV4Planes As Integer
        bV4BitCount As Integer
        bV4V4Compression As Long
        bV4SizeImage As Long
        bV4XPelsPerMeter As Long
        bV4YPelsPerMeter As Long
        bV4ClrUsed As Long
        bV4ClrImportant As Long
        bV4RedMask As Long
        bV4GreenMask As Long
        bV4BlueMask As Long
        bV4AlphaMask As Long
        bV4CSType As Long
        bV4Endpoints As Long
        bV4GammaRed As Long
        bV4GammaGreen As Long
        bV4GammaBlue As Long
End Type

Private Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors As RGBQUAD
End Type

Private Type BITMAPV4INFO
        bmiHeader As BITMAPV4HEADER
        bmiColors As RGBQUAD
End Type

Private Type BITMAPCOREHEADER
        bcSize As Long
        bcWidth As Integer
        bcHeight As Integer
        bcPlanes As Integer
        bcBitCount As Integer
End Type

Private Type BITMAPCOREINFO
        bmciHeader As BITMAPCOREHEADER
        bmciColors As RGBTRIPLE
End Type

Private Type BITMAP
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

Private Type ICONINFO
        fIcon As Long
        xHotspot As Long
        yHotspot As Long
        hbmMask As Long
        hbmColor As Long
End Type

Private Type ICONMETRICS
    cbSize As Long
    iHorzSpacing As Long
    iVertSpacing As Long
    iTitleWrap As Long
    lfFont As LOGFONT
End Type

' Old NotifyIconData

Private Type NOTIFYICONDATA
        cbSize As Long
        Hwnd As Long
        uID As Long
        uFlags As Long
        uCallbackMessage As Long
        hIcon As Long
        szTip As String * 64
End Type

' NotifyIconData for Window NT 5.0& (Windows 2000)

Private Type NOTIFYICONDATA5
    cbSize As Long
    Hwnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 128
    dwState As Long
    dwStateMask As Long
    szInfo As String * 256
    uVersion As Long
    szInfoTitle As String * 64
    dwInfoFlags As Long
End Type


'' 2000+ GetVersionEx structure

Private Type OSVERSIONINFOEX
    OSVersionInfoSize As Long
    MajorVersion As Long
    MinorVersion As Long
    BuildNumber As Long
    PlatformId As Long
    CSDVersion As String * 128
    ServicePackMajor As Integer
    ServicePackMinor As Integer
    Reserved(0& To 1) As Integer
End Type

'' Old GetVersionEx structure

Private Type OSVERSIONINFO
        OSVersionInfoSize As Long
        MajorVersion As Long
        MinorVersion As Long
        BuildNumber As Long
        PlatformId As Long
        CSDVersion As String * 128      '  Maintenance string for PSS usage
End Type

'' Windows version constants enumerated (100 * Maj) + Min method

Private Enum WindowsVersionConstants
    Windows95 = 400
    WindowsNT = 400
    Windows98 = 410
    WindowsME = 490
    Windows2000 = 500
End Enum



Private Type PAINTSTRUCT
    hdc As Long
    fErase As Boolean
    rcpaint As RECT
    fRestore As Boolean
    fIncUpdate As Boolean
    rgbReserved(0 To 31) As Byte
End Type

' Old NotifyIconData

' NotifyIconData for Window NT 5.0& (Windows 2000)

''' Menu event records

Private Type MENU_EVENT_RECORD
        dwCommandId As Long
End Type

''' Menu item info for 95-2000

Private Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As Long
    cch As Long
    
    ' Declared for Windows 2000/98.  Still backward compatible
    
    hbmpItem As Long
End Type

'' With string data.

Private Type MENUITEMINFOSTRING
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
    
    ' Declared for Windows 2000/98.  Still backward compatible
    
    hbmpItem As Long
End Type

''' Item template

Private Type MENUITEMTEMPLATE
        mtOption As Integer
        mtID As Integer
        mtString As Byte
End Type

''' Template header

Private Type MENUITEMTEMPLATEHEADER
        versionNumber As Integer
        Offset As Integer
End Type

''' Template parameters

Private Type TPMPARAMS
    cbSize As Long
    rcExclude As RECT
End Type

''' New for Windows 2000/98

Private Type MENUINFO
    cbSize As Long
    fMask As Long
    dwStyle As Long
    cyMax As Long
    Back As Long
    ContextHelpID As Long
    MenuData As Long
End Type

Private Type MENUBARINFO
    cbSize As Long
    rcBar As RECT
    hMenu As Long
    hWndMenu As Long
    fBarFocused As Boolean
    fFocused As Boolean
End Type

Private Type ACCEL
        fVirt As Byte
        Key As Integer
        cmd As Integer
End Type

Private Type MSG
    Hwnd As Long
    Message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

Private Type WNDCLASS
    Style As Long
    lpfnwndproc As Long
    cbClsextra As Long
    cbWndExtra2 As Long
    hInstance As Long
    hIcon As Long
    hCursor As Long
    hbrBackground As Long
    lpszMenuName As Long
    lpszClassName As Long
End Type

Private Type SCROLLINFO
    cbSize As Long
    fMask As Long
    nMin As Long
    nMax As Long
    nPage As Long
    nPos As Long
    nTrackPos As Long
End Type

Private Type DIBDATA
    hdc As Long
    hBitmap As Long
    
    info As BITMAPINFO
    Bytes() As Byte
End Type


'' ****** DECLARES ******

Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
Private Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hdc As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As Any) As Long

Private Declare Function SetActiveWindow Lib "user32" (ByVal Hwnd As Long) As Long

Private Declare Function SetWindowExtEx Lib "gdi32" (ByVal hdc As Long, ByVal nx As Long, ByVal ny As Long, lpSize As SIZEAPI) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowOrgEx Lib "gdi32" (ByVal hdc As Long, ByVal nx As Long, ByVal ny As Long, lpPoint As POINTAPI) As Long
Private Declare Function SetWindowPlacement Lib "user32" (ByVal Hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal Hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal Hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function SetWindowWord Lib "user32" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal wNewWord As Long) As Long

Private Declare Function GetWindowExtEx Lib "gdi32" (ByVal hdc As Long, lpSize As SIZEAPI) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long) As Long

Private Declare Function GetWindowOrgEx Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetWindowPlacement Lib "user32" (ByVal Hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal Hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowRgn Lib "user32" (ByVal Hwnd As Long, ByVal hRgn As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal Hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal Hwnd As Long) As Long
Private Declare Function SetFocus Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function GetFocus Lib "user32" () As Long

'' other API functions

Private Declare Function CreateCaret Lib "user32" (ByVal Hwnd As Long, ByVal hBitmap As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function ShowCaret Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function SetCaretBlinkTime Lib "user32" (ByVal wMSeconds As Long) As Long
Private Declare Function SetCaretPos Lib "user32" (ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GetCaretBlinkTime Lib "user32" () As Long
Private Declare Function GetCaretPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function HideCaret Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function DestroyCaret Lib "user32" () As Long

Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateRectRgnIndirect Lib "gdi32" (lpRect As RECT) As Long

Private Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long
Private Declare Function LoadCursorA Lib "user32" (ByVal hInstance As Long, ByVal lpCursorName As String) As Long
Private Declare Function LoadCursorW Lib "user32" (ByVal hInstance As Long, ByVal lpCursorName As String) As Long

Private Declare Function GetDesktopWindow Lib "user32" () As Long

Private Declare Function GetClientRect Lib "user32" (ByVal Hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetParent Lib "user32" (ByVal Hwnd As Long) As Long

Private Declare Function GetTopWindow Lib "user32" (ByVal Hwnd As Long) As Long

Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Private Declare Function DestroyWindow Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal Hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Function MoveWindow Lib "user32" (ByVal Hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageW Lib "user32" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent As Long, ByVal lpEnumFunc As Long, lParam As Any) As Long

''' GDI declares

Private Declare Function GdiFlush Lib "gdi32" () As Long

Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long

Private Declare Function CopyImage Lib "user32" (ByVal Handle As Long, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal hBitmap As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function GetIconInfo Lib "user32" (ByVal hIcon As Long, piconinfo As ICONINFO) As Long

Private Declare Function EnumFontFamiliesEx Lib "gdi32" Alias "EnumFontFamiliesExA" (ByVal hdc As Long, lpLogFont As LOGFONT, ByVal lpEnumFontProc As Long, ByVal lParam As Long, ByVal dw As Long) As Long
Private Declare Function EnumFontFamiliesExW Lib "gdi32" (ByVal hdc As Long, lpLogFont As LOGFONT, ByVal lpEnumFontProc As Long, ByVal lParam As Long, ByVal dw As Long) As Long

'' mapping mode functions

Private Declare Function LPtoDP Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function DPtoLP Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal Hwnd As Long, lpPoint As POINTAPI) As Long

Private Declare Function GetMapMode Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetMapMode Lib "gdi32" (ByVal hdc As Long, ByVal nMapMode As Long) As Long

''' Draw disabled/enabled icons/bitmaps and text

Private Declare Function DrawState Lib "user32" Alias "DrawStateA" (ByVal hdc As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As Long, ByVal wParam As Long, ByVal n1 As Integer, ByVal n2 As Integer, ByVal n3 As Integer, ByVal n4 As Integer, ByVal un As Long) As Long
Private Declare Function DrawStateW Lib "user32" (ByVal hdc As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As Long, ByVal wParam As Long, ByVal n1 As Integer, ByVal n2 As Integer, ByVal n3 As Integer, ByVal n4 As Integer, ByVal un As Long) As Long
Private Declare Function DrawStateB Lib "user32" Alias "DrawStateA" (ByVal hdc As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As String, ByVal wParam As Long, ByVal n1 As Integer, ByVal n2 As Integer, ByVal n3 As Integer, ByVal n4 As Integer, ByVal un As Long) As Long
Private Declare Function DrawStateBW Lib "user32" Alias "DrawStateW" (ByVal hdc As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As String, ByVal wParam As Long, ByVal n1 As Integer, ByVal n2 As Integer, ByVal n3 As Integer, ByVal n4 As Integer, ByVal un As Long) As Long

''' Set the painting colors of the device context

Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal ColorRef As Long) As Long

Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long

'' Set background OPAQUE or TRANSPARENT

Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long

'' ROP2

Private Declare Function SetROP2 Lib "gdi32" (ByVal hdc As Long, ByVal nDrawMode As Long) As Long
Private Declare Function GetROP2 Lib "gdi32" (ByVal hdc As Long) As Long

'' Get colorref from system color index

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Private Declare Function SetCapture Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long

'' Device context functions

Private Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Private Declare Function WindowFromDC Lib "user32" (ByVal hdc As Long) As Long

Private Declare Function GetDC Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function GetDCOrgEx Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI) As Long
Private Declare Function SaveDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function RestoreDC Lib "gdi32" (ByVal hdc As Long, ByVal nSavedDC As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal Hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function RectVisible Lib "gdi32" (ByVal hdc As Long, lpRect As RECT) As Long
Private Declare Function PtVisible Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

Private Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Private Declare Function SetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long

Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As Any, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As Any, ByVal wUsage As Long) As Long

Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal srcX As Long, ByVal srcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As Any, ByVal wUsage As Long) As Long

Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hdc As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, lpVoid As Long, ByVal Handle As Long, ByVal dw As Long) As Long

Private Declare Function VirtualFree Lib "kernel32" (lpAddress As Any, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long

Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetCurrentObject Lib "gdi32" (ByVal hdc As Long, ByVal uObjectType As Long) As Long
Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long

Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long

Private Declare Function GetObjectW Lib "gdi32" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long

Private Declare Function ExtCreatePen Lib "gdi32" (ByVal dwPenStyle As Long, ByVal dwWidth As Long, lplb As LOGBRUSH, ByVal dwStyleCount As Long, lpStyle As Long) As Long
Private Declare Function CreatePenIndirect Lib "gdi32" (lpLogPen As LOGPEN) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function CreateBrushIndirect Lib "gdi32" (lpLogBrush As LOGBRUSH) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateBitmapIndirect Lib "gdi32" (lpBitmap As BITMAP) As Long
Private Declare Function CreateIconIndirect Lib "user32" (piconinfo As ICONINFO) As Long

''' Measuring, Coloring and Drawing Text

Private Declare Function SetTextAlign Lib "gdi32" (ByVal hdc As Long, ByVal wFlags As Long) As Long
Private Declare Function GetTextAlign Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As Long, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function DrawTextW Lib "user32" (ByVal hdc As Long, ByVal lpStr As Long, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long

Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As Long, ByVal nCount As Long) As Long
Private Declare Function TextOutW Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As Long, ByVal nCount As Long) As Long

Private Declare Function ExtTextOut Lib "gdi32" Alias "ExtTextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal wOptions As Long, ByVal lpRect As Long, ByVal lpString As Long, ByVal nCount As Long, ByVal lpDx As Long) As Long
Private Declare Function ExtTextOutW Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal wOptions As Long, ByVal lpRect As Long, ByVal lpString As Long, ByVal nCount As Long, ByVal lpDx As Long) As Long

Private Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hdc As Long, ByVal lpsz As Long, ByVal cbString As Long, lpSize As SIZEAPI) As Long
Private Declare Function GetTextExtentPoint32W Lib "gdi32" (ByVal hdc As Long, ByVal lpsz As Long, ByVal cbString As Long, lpSize As SIZEAPI) As Long

Private Declare Function GetCharacterPlacement Lib "gdi32" Alias " GetCharacterPlacementA" (ByVal hdc As Long, ByVal lpsz As Long, ByVal n1 As Long, ByVal n2 As Long, lpGcpResults As GCP_RESULTS, ByVal dw As Long) As Long
Private Declare Function GetCharacterPlacementW Lib "gdi32" Alias " GetCharacterPlacementW" (ByVal hdc As Long, ByVal lpsz As Long, ByVal n1 As Long, ByVal n2 As Long, lpGcpResults As GCP_RESULTS, ByVal dw As Long) As Long

Private Declare Function GetFontLanguageInfo Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long

Private Declare Function RedrawWindow2 Lib "user32" Alias "RedrawWindow" (ByVal Hwnd As Long, ByVal lprcUpdate As Long, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long
Private Declare Function RedrawWindow Lib "user32" (ByVal Hwnd As Long, lprcUpdate As RECT, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal Hwnd As Long, ByVal nCmdShow As Long) As Long

'' draw icon

Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal hIcon As Long) As Long

'' draw 3d edge

Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long

'' draw caption text

Private Declare Function DrawCaption Lib "user32" (ByVal Hwnd As Long, ByVal hdc As Long, pcRect As RECT, ByVal un As Long) As Long

'' draw a frame

Private Declare Function DrawFrameControl Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long

'' draw a line

Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

'' fill rectangle

Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long

'' flood fill

Private Declare Function FloodFill Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long


'' Move painting origin on the canvas of the device

Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal nXOrg As Long, ByVal nYOrg As Long, lppt As POINTAPI) As Long
Private Declare Function SetBrushOrgEx Lib "gdi32" (ByVal hdc As Long, ByVal nXOrg As Long, ByVal nYOrg As Long, lppt As POINTAPI) As Long

Private Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwROP As Long) As Long

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwROP As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long


'' Ole Functions

Private Declare Function OleCreateFontIndirect Lib "olepro32" (pFontDesc As Any, riid As GUID, pFont As StdFont) As Long
Private Declare Function OleCreatePictureIndirect Lib "olepro32" (ByVal Pict As Long, riid As GUID, fOwn As Boolean, ppvObj As Object) As Long

'' Muldiv
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Private Declare Function SetCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function GetCursor Lib "user32" () As Long
' Shell_NotifyIconA if OSVersion <= 4

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long

' Shell_NotifyIconA if OSVersion >= 5

Private Declare Function Shell_NotifyIcon5 Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA5) As Long

'' Scroll Bar Functions

Private Declare Function SetScrollInfo Lib "user32" (ByVal Hwnd As Long, ByVal n As Long, ByRef lpcScrollInfo As SCROLLINFO, ByVal bool As Boolean) As Long
Private Declare Function SetScrollPos Lib "user32" (ByVal Hwnd As Long, ByVal nBar As Long, ByVal nPos As Long, ByVal bRedraw As Long) As Long
Private Declare Function SetScrollRange Lib "user32" (ByVal Hwnd As Long, ByVal nBar As Long, ByVal nMinPos As Long, ByVal nMaxPos As Long, ByVal bRedraw As Long) As Long
Private Declare Function GetScrollInfo Lib "user32" (ByVal Hwnd As Long, ByVal n As Long, ByRef lpScrollInfo As SCROLLINFO) As Long
Private Declare Function GetScrollPos Lib "user32" (ByVal Hwnd As Long, ByVal nBar As Long) As Long
Private Declare Function GetScrollRange Lib "user32" (ByVal Hwnd As Long, ByVal nBar As Long, ByRef lpMinPos As Long, ByRef lpMaxPos As Long) As Long
Private Declare Function EnableScrollBar Lib "user32" (ByVal Hwnd As Long, ByVal wSBflags As Long, ByVal wArrows As Long) As Long
Private Declare Function ShowScrollBar Lib "user32" (ByVal Hwnd As Long, ByVal wBar As Long, ByVal bShow As Long) As Long

Private Declare Function ScrollDC Lib "user32" (ByVal hdc As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, lprcClip As RECT, ByVal hrgnUpdate As Long, lprcUpdate As RECT) As Long
Private Declare Function ScrollWindow Lib "user32" (ByVal Hwnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, lpRect As RECT, lpClipRect As Any) As Long
Private Declare Function ScrollWindowEx Lib "user32" (ByVal Hwnd As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, lprcClip As RECT, ByVal hrgnUpdate As Long, lprcUpdate As RECT, ByVal fuScroll As Long) As Long

'' Menu API functions

Private Declare Function GetMessage Lib "user32" Alias "GetMessageA" (lpMsg As MSG, ByVal Hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Private Declare Function PeekMessage Lib "user32" Alias "PeekMessageA" (lpMsg As MSG, ByVal Hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long, ByVal wRemoveMsg As Long) As Long

Private Declare Function TranslateMessage Lib "user32" (lpMsg As MSG) As Long
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

Private Declare Function CopyAcceleratorTable Lib "user32" Alias "CopyAcceleratorTableA" (ByVal hAccelSrc As Long, ByVal lpAccelDst As Long, ByVal cAccelEntries As Long) As Long
Private Declare Function CreateAcceleratorTable Lib "user32" Alias "CreateAcceleratorTableA" (ByVal lpaccl As Long, ByVal cEntries As Long) As Long
Private Declare Function TranslateAccelerator Lib "user32" Alias "TranslateAcceleratorA" (ByVal Hwnd As Long, ByVal hAccTable As Long, lpMsg As MSG) As Long
Private Declare Function DestroyAcceleratorTable Lib "user32" (ByVal haccel As Long) As Long

Private Declare Function TrackPopupMenu Lib "user32" (ByVal Handle As Long, ByVal wFlags As Long, ByVal x As Long, ByVal y As Long, ByVal nReserved As Long, ByVal Hwnd As Long, lprc As RECT) As Long
Private Declare Function TrackPopupMenuEx Lib "user32" (ByVal Handle As Long, ByVal un As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal Hwnd As Long, lpTPMParams As TPMPARAMS) As Long

Private Declare Function DrawMenuBar Lib "user32" (ByVal Hwnd As Long) As Long

Private Declare Function CreatePopupMenu Lib "user32" () As Long
Private Declare Function CreateMenu Lib "user32" () As Long
Private Declare Function DeleteMenu Lib "user32" (ByVal Handle As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long

Private Declare Function InsertMenuItem Lib "user32" Alias "InsertMenuItemA" (ByVal Handle As Long, ByVal un As Long, ByVal bool As Boolean, ByRef lpcMenuItemInfo As MENUITEMINFO) As Long
Private Declare Function InsertMenuItemW Lib "user32" (ByVal Handle As Long, ByVal un As Long, ByVal bool As Boolean, ByRef lpcMenuItemInfo As MENUITEMINFO) As Long

Private Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal Handle As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Private Declare Function AppendMenuW Lib "user32" (ByVal Handle As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long

Private Declare Function InsertMenu Lib "user32" Alias "InsertMenuA" (ByVal Handle As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Private Declare Function InsertMenuW Lib "user32" (ByVal Handle As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long

Private Declare Function RemoveMenu Lib "user32" (ByVal Handle As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Function DestroyMenu Lib "user32" (ByVal Handle As Long) As Long

Private Declare Function GetSystemMenu Lib "user32" (ByVal Hwnd As Long, ByVal bRevert As Long) As Long

Private Declare Function GetMenuItemCount Lib "user32" (ByVal Handle As Long) As Long
Private Declare Function GetMenuItemID Lib "user32" (ByVal Handle As Long, ByVal nPos As Long) As Long
Private Declare Function GetMenuDefaultItem Lib "user32" (ByVal Handle As Long, ByVal fByPos As Long, ByVal gmdiFlags As Long) As Long
Private Declare Function GetMenuContextHelpId Lib "user32" (ByVal Handle As Long) As Long
Private Declare Function GetMenuCheckMarkDimensions Lib "user32" () As Long

Private Declare Function GetMenu Lib "user32" (ByVal Hwnd As Long) As Long

Private Declare Function GetMenuItemInfo Lib "user32" Alias "GetMenuItemInfoA" (ByVal Handle As Long, ByVal un As Long, ByVal b As Long, lpMenuItemInfo As MENUITEMINFO) As Long
Private Declare Function GetMenuItemInfoW Lib "user32" (ByVal Handle As Long, ByVal un As Long, ByVal b As Long, lpMenuItemInfo As MENUITEMINFO) As Long

Private Declare Function GetMenuInfo Lib "user32" (ByVal hMenu As Long, lpcmi As MENUINFO) As Long
Private Declare Function GetMenuBarInfo Lib "user32" (ByVal Hwnd As Long, ByVal idObject As Long, ByVal idItem As Long, pmbi As MENUBARINFO) As Long

Private Declare Function GetMenuItemRect Lib "user32" (ByVal Hwnd As Long, ByVal Handle As Long, ByVal uItem As Long, lprcItem As RECT) As Long
Private Declare Function GetMenuState Lib "user32" (ByVal Handle As Long, ByVal wID As Long, ByVal wFlags As Long) As Long

Private Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal Handle As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Private Declare Function GetMenuStringW Lib "user32" (ByVal Handle As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long

Private Declare Function SetMenuInfo Lib "user32" (ByVal hMenu As Long, lpcmi As MENUINFO) As Long

Private Declare Function SetMenu Lib "user32" (ByVal Hwnd As Long, ByVal Handle As Long) As Long
Private Declare Function SetMenuContextHelpId Lib "user32" (ByVal Handle As Long, ByVal dw As Long) As Long
Private Declare Function SetMenuDefaultItem Lib "user32" (ByVal Handle As Long, ByVal uItem As Long, ByVal fByPos As Long) As Long
Private Declare Function SetMenuItemBitmaps Lib "user32" (ByVal Handle As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long
Private Declare Function EnableMenuItem Lib "user32" (ByVal hMenu As Long, ByVal wIDEnableItem As Long, ByVal wEnable As Long) As Long

Private Declare Function SetMenuItemInfo Lib "user32" Alias "SetMenuItemInfoA" (ByVal Handle As Long, ByVal un As Long, ByVal bool As Boolean, lpcMenuItemInfo As MENUITEMINFO) As Long
Private Declare Function SetMenuItemInfoW Lib "user32" (ByVal Handle As Long, ByVal un As Long, ByVal bool As Boolean, lpcMenuItemInfo As MENUITEMINFO) As Long

''' Windows 98/2000

Private Declare Function GradientFillRect Lib "gdi32" Alias "GradientFill" (ByVal hdc As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_RECT, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Boolean


''' GDI declaresprivate Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent As Long, ByVal lpEnumFunc As Long, lParam As Any) As Long

Private Declare Function GetLastError Lib "kernel32" () As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Private Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Private Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal nCode As Long, ByVal wParam As Long, lParam As Any) As Long

Private Declare Function GetVersion Lib "kernel32" Alias "GetVersionExA" (pData As OSVERSIONINFO) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (pData As OSVERSIONINFOEX) As Long

Private Declare Sub ExitProcess Lib "kernel32" (ByVal uExitCode As Long)
Private Declare Sub ExitThread Lib "kernel32" (ByVal dwExitCode As Long)
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Private Declare Function TerminateThread Lib "kernel32" (ByVal hThread As Long, ByVal dwExitCode As Long) As Long

Private Declare Function SetTimer Lib "user32" (ByVal Hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal Hwnd As Long, ByVal nIDEvent As Long) As Long

Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function CreateWindowEx2 Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As Long, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long

Private Declare Function GetClassInfo Lib "user32" Alias "GetClassInfoA" (ByVal hInstance As Long, ByVal lpClassName As Long, lpWndClass As WNDCLASS) As Long
Private Declare Function GetClassInfoW Lib "user32" (ByVal hInstance As Long, ByVal lpClassName As Long, lpWndClass As WNDCLASS) As Long

Private Declare Function RegisterClass Lib "user32" Alias "RegisterClassA" (Class As WNDCLASS) As Long
Private Declare Function UnregisterClass Lib "user32" Alias "UnregisterClassA" (ByVal lpClassName As Long, ByVal hInstance As Long) As Long

Private Declare Function RegisterClassW Lib "user32" (Class As WNDCLASS) As Long
Private Declare Function UnregisterClassW Lib "user32" (ByVal lpClassName As Long, ByVal hInstance As Long) As Long

Private Declare Function UpdateWindow Lib "user32" (ByVal Hwnd As Long) As Long

Private Declare Function InvalidateRect Lib "user32" (ByVal Hwnd As Long, ByVal lpRect As Long, ByVal fErase As Long) As Long
Private Declare Function BeginPaint Lib "user32" (ByVal Hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function EndPaint Lib "user32" (ByVal Hwnd As Long, lpPaint As PAINTSTRUCT) As Long

'' verification functions


Private Declare Function IsBadCodePtr Lib "kernel32" (ByVal lpfn As Long) As Long
Private Declare Function IsBadHugeReadPtr Lib "kernel32" (lp As Any, ByVal ucb As Long) As Long
Private Declare Function IsBadHugeWritePtr Lib "kernel32" (lp As Any, ByVal ucb As Long) As Long
Private Declare Function IsBadReadPtr Lib "kernel32" (lp As Any, ByVal ucb As Long) As Long
Private Declare Function IsBadStringPtr Lib "kernel32" Alias "IsBadStringPtrA" (ByVal lpsz As String, ByVal ucchMax As Long) As Long
Private Declare Function IsBadWritePtr Lib "kernel32" (lp As Any, ByVal ucb As Long) As Long

Private Declare Function IsWindowEnabled Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal Hwnd As Long) As Long

Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalHandle Lib "kernel32" (wMem As Any) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalReAlloc Lib "kernel32" (ByVal hMem As Long, ByVal dwBytes As Long, ByVal wFlags As Long) As Long
Private Declare Function GlobalSize Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function RegisterClipboardFormat Lib "user32" Alias "RegisterClipboardFormatA" (ByVal lpString As String) As Long
Private Declare Function OpenClipboard Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function CloseClipboard Lib "user32" () As Long

Private Declare Function GetClipboardData Lib "user32" (ByVal wFormat As Long) As Long
Private Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long

Private Declare Function EmptyClipboard Lib "user32" () As Long


Private MrkCount As Double
Private MrkSize As SIZEAPI

Private m_pDC As Long
Private m_pBitmap As Long

Private m_pTextDC As Long
Private m_pTextBitmap As Long

Private m_pTextBrush As Long

Private m_pBrush As Long
Private m_pFont As Long



Public Enum ProgressBarStyles
    psMagicSquares = 0&
    psFade = 1&
End Enum

Public Enum TextAlignConstants
    taLeft = 0&
    taRight = 1
    taCenter = 2
End Enum

Public Enum TextVAlignConstants
    taTop = 0&
    taBottom = 1&
End Enum

Public Enum OrientationConstants
    ocHorizontal = 1
    ocHorizontalRightToLeft = 3
    ocVertical = 4
    ocVerticalBottomToTop = 6
End Enum

Private Const ReverseMask = 2

Public Enum BorderStyleConstants
    bsNone = 0&
    bsSunken3D = 1
    bsRaised3D = 2
    bsSunkenBox = 3
    bsRaisedBox = 4
End Enum

Private m_DoEvents As Boolean

Private m_ClickableTiles As Boolean
Private m_TileDown As Long

Private m_MaxValue As Double
Private m_MinValue As Double
Private m_Value As Double

Private m_Style As ProgressBarStyles

Private m_Orientation As OrientationConstants
Private m_BorderStyle As BorderStyleConstants

Private m_TextBorderStyle As BorderStyleConstants

Private m_BackColor As OLE_COLOR
Private m_ForeColor As OLE_COLOR

Private m_TextColor As OLE_COLOR
Private m_TextBkColor As OLE_COLOR

Public WithEvents m_Font As StdFont
Attribute m_Font.VB_VarHelpID = -1

Private m_Text As String
Private m_TextAreaHeight As Long

Private m_TextAlign As TextAlignConstants
Private m_TextVAlign As TextVAlignConstants

Private m_TextArea As RECT

Private m_ValFmt As String
Private m_PercFmt As String

Public Event TileClick(ByVal TileNumber As Long, ByVal TileCount As Long, ByVal Button As Integer)



Private Function GetActualColor(ByVal OleValue As OLE_COLOR) As Long

    If (OleValue And &H80000000) Then
        GetActualColor = GetSysColor(OleValue And &H7FF)
    Else
        GetActualColor = OleValue
    End If
End Function

Private Function CompRect(lpRect1 As RECT, lpRect2 As RECT) As Long

    Dim c As RECT
    
    c.Left = Abs(lpRect1.Left - lpRect2.Left)
    c.Top = Abs(lpRect1.Top - lpRect2.Top)
    c.Right = Abs(lpRect1.Right - lpRect2.Right)
    c.Bottom = Abs(lpRect1.Bottom - lpRect2.Bottom)
    
    CompRect = CLng(CDbl(c.Left + c.Top + c.Right + c.Bottom) / 4#)
    
End Function

Private Function WithinRect(rcBounds As RECT, ByVal x As Long, ByVal y As Long) As Boolean
    If ((rcBounds.Left <= x) And (rcBounds.Right >= x)) And _
        ((rcBounds.Top <= y) And (rcBounds.Bottom >= y)) Then
        
        WithinRect = True
    Else
        WithinRect = False
    End If
End Function

Private Function WithinRectPt(rcBounds As RECT, pt As POINTAPI) As Boolean
    With pt
        If ((rcBounds.Left <= .x) And (rcBounds.Right >= .x)) And _
            ((rcBounds.Top <= .y) And (rcBounds.Bottom >= .y)) Then
            
            WithinRectPt = True
        Else
            WithinRectPt = False
        End If
    End With
End Function

Private Function PointFromLong(ByVal lParam As Long, lpPoint As POINTAPI)
    Dim pt(0 To 1) As Integer
    
    CopyMemory pt(0), lParam, 4
    lpPoint.x = pt(0)
    lpPoint.y = pt(1)

End Function


Private Function PointToLong(lpPoint As POINTAPI, lParam As Long)
    Dim pt(0 To 1) As Integer
    
    pt(0) = CInt(lpPoint.x)
    pt(1) = CInt(lpPoint.y)
    
    CopyMemory lParam, pt(0), 4

End Function

Private Function ExpandRect(lpRect As RECT, ByVal Value As Long)
    lpRect.Left = lpRect.Left - Value
    lpRect.Top = lpRect.Top - Value
    lpRect.Right = lpRect.Right + Value
    lpRect.Bottom = lpRect.Bottom + Value
End Function

Private Function DimToRect(lpDims As DIMAPI, lpRect As RECT)

    lpRect.Left = lpDims.Left
    lpRect.Top = lpDims.Top
    
    lpRect.Right = lpDims.Left + lpDims.Width
    lpRect.Bottom = lpDims.Top + lpDims.Height
    
    lpRect.Right = lpRect.Right - 1
    lpRect.Bottom = lpRect.Bottom - 1
End Function

Private Function RectToDim(lpRect As RECT, lpDims As DIMAPI)

    lpDims.Left = lpRect.Left
    lpDims.Top = lpRect.Top
    
    lpDims.Width = (lpRect.Right - lpRect.Left) + 1
    lpDims.Height = (lpRect.Bottom - lpRect.Top) + 1
    
End Function

Private Function BoundryX(lpRect As RECT, ByVal x As Long) As Long

    If Abs(lpRect.Left - x) < Abs(lpRect.Right - x) Then
        BoundryX = Abs(lpRect.Left - x)
    Else
        BoundryX = Abs(lpRect.Right - x)
    End If

End Function

Private Function BoundryY(lpRect As RECT, ByVal y As Long) As Long

    If Abs(lpRect.Top - y) < Abs(lpRect.Bottom - y) Then
        BoundryY = Abs(lpRect.Top - y)
    Else
        BoundryY = Abs(lpRect.Bottom - y)
    End If

End Function

Private Function NearBoundry(lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long

    Dim ax As Long, _
        ay As Long
        
    ax = BoundryX(lpRect, x)
    ay = BoundryY(lpRect, y)
    
    If (ax < ay) Then NearBoundry = ax Else NearBoundry = ay

End Function

Private Function Pex(Value) As String
    Dim v As String, _
        i As Integer
        
    Dim c As Integer
        
    i = Len(Hex(Value))
    
    Select Case VarType(Value)
        Case vbByte:
            c = 2
        Case vbInteger:
            c = 4
        Case vbLong:
            c = 8
    End Select

    v = String(c - i, "0")
    v = v + Hex(Value)
    Pex = v
End Function



Private Function ShiftRect(lpRect As RECT, cx, cy)

    With lpRect
        .Left = .Left + cx
        .Top = .Top + cy
        .Right = .Right + cx
        .Bottom = .Bottom + cy
    End With
    
End Function


Private Function RectBltD(ByVal hdcDest As Long, lprcDest As RECT, _
                            ByVal hdcSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, _
                            ByVal dwROP As Long) As Long
    
    Dim cx As Long, _
        cy As Long
    
    Dim x As Long, _
        y As Long
    
    With lprcDest
        x = .Left
        y = .Top
        cx = (.Right - .Left) + 1
        cy = (.Bottom - .Top) + 1
    End With
        
    RectBltD = BitBlt(hdcDest, x, y, cx, cy, hdcSrc, xSrc, ySrc, dwROP)
                    
End Function


Private Function RectBltS(ByVal hdcDest As Long, ByVal xDest As Long, ByVal yDest As Long, _
                            ByVal hdcSrc As Long, lprcSrc As RECT, _
                            ByVal dwROP As Long) As Long
    
    Dim cx As Long, _
        cy As Long
    
    Dim x As Long, _
        y As Long
    
    With lprcSrc
        x = .Left
        y = .Top
        cx = (.Right - .Left) + 1
        cy = (.Bottom - .Top) + 1
    End With
        
    RectBltS = BitBlt(hdcDest, xDest, yDest, cx, cy, hdcSrc, x, y, dwROP)
                    
End Function




Public Property Get TextAreaHeight() As Long
    TextAreaHeight = m_TextAreaHeight
End Property

Public Property Let TextAreaHeight(ByVal varNew As Long)
    If (m_TextAreaHeight <> varNew) Then
    
        m_TextAreaHeight = varNew
        PropertyChanged "TextAreaHeight"
        
        UserControl_Paint
    End If
End Property

Public Property Get ClickableTiles() As Boolean
    ClickableTiles = m_ClickableTiles
End Property

Public Property Let ClickableTiles(ByVal varNew As Boolean)
    If (m_ClickableTiles <> varNew) Then
        
        m_ClickableTiles = varNew
        PropertyChanged "ClickableTiles"
        UserControl_Paint
    End If
    
End Property

Public Property Get TextAlign() As TextAlignConstants
    TextAlign = m_TextAlign
End Property

Public Property Get TextVAlign() As TextVAlignConstants
    TextVAlign = m_TextVAlign
End Property

Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text format string that will be displayed in the control.\r\n\r\nEscape codes are: \\p - percentage, \\v - Value, \\m - MaxValue, \\z - MinValue"
Attribute Text.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute Text.VB_UserMemId = -517
    Text = m_Text
End Property

Public Property Get PercentFormat() As String
Attribute PercentFormat.VB_Description = "Returns/sets the format string for percentage values inserted into the control text with the '\\p' escape code."
Attribute PercentFormat.VB_ProcData.VB_Invoke_Property = ";Appearance"
    PercentFormat = m_PercFmt
End Property

Public Property Get ValueFormat() As String
Attribute ValueFormat.VB_Description = "Returns/sets the format string for values inserted into the control text with the '\\v','\\m' & '\\z'   escape codes."
Attribute ValueFormat.VB_ProcData.VB_Invoke_Property = ";Appearance"
    ValueFormat = m_ValFmt
End Property

Public Property Get DoAppEvents() As Boolean
Attribute DoAppEvents.VB_Description = "Returns/sets a value indicating whether the control will process application events after completing a paint procedure."
Attribute DoAppEvents.VB_ProcData.VB_Invoke_Property = ";Behavior"
    DoAppEvents = m_DoEvents
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Click the ellipses to open the font properties dialog."
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont;Font"
Attribute Font.VB_UserMemId = -512
    Set Font = m_Font
End Property

Public Property Get MaxValue() As Double
Attribute MaxValue.VB_Description = "Returns/sets the maximum allowable value of the 'Value' property."
Attribute MaxValue.VB_ProcData.VB_Invoke_Property = ";Behavior"
    MaxValue = m_MaxValue
End Property

Public Property Get MinValue() As Double
Attribute MinValue.VB_Description = "Returns/sets the minimum allowable value of the 'Value' property."
Attribute MinValue.VB_ProcData.VB_Invoke_Property = ";Behavior"
    MinValue = m_MinValue
End Property

Public Property Get Value() As Double
Attribute Value.VB_Description = "Returns/sets the value of the internal counter of the control.  The allowable values range is defined by the MinValue and MaxValue properties."
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Data"
Attribute Value.VB_UserMemId = 0
Attribute Value.VB_MemberFlags = "200"
    Value = m_Value
End Property

Public Property Get Style() As ProgressBarStyles
    Style = m_Style
End Property

Public Property Get BorderStyle() As BorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style of the control.\r\nbsRaised - Draws the control similar to a button.\r\nbsSunken - draws the control similar to a window.\r\nbsNone - Draws no border around the control."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_BorderStyle
End Property

Public Property Get TextBorderStyle() As BorderStyleConstants
    TextBorderStyle = m_TextBorderStyle
End Property

Public Property Get Orientation() As OrientationConstants
Attribute Orientation.VB_Description = "Returns/sets the orientation of the control."
Attribute Orientation.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Orientation = m_Orientation
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background fill color of the control."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = m_BackColor
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground fill color of the control."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = m_ForeColor
End Property

Public Property Get TextColor() As OLE_COLOR
Attribute TextColor.VB_Description = "Returns/sets the text color of the control."
Attribute TextColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    TextColor = m_TextColor
End Property

Public Property Get TextBkColor() As OLE_COLOR
    TextBkColor = m_TextBkColor
End Property

Public Property Let TextAlign(ByVal varNew As TextAlignConstants)
Attribute TextAlign.VB_Description = "Returns/sets the text alignment of the control."
Attribute TextAlign.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
    If m_TextAlign <> varNew Then
        m_TextAlign = varNew
        PropertyChanged "TextAlign"
        
        UpdateText
    End If
    
End Property

Public Property Let TextVAlign(ByVal varNew As TextVAlignConstants)
    If m_TextVAlign <> varNew Then
        
        m_TextVAlign = varNew
        PropertyChanged "TextVAlign"
        
        MeasureTextArea
        UserControl_Paint
    End If
    
End Property

Public Property Let Text(ByVal varNew As String)
    
    If varNew <> m_Text Then
        m_Text = varNew
        PropertyChanged "Text"
        
        UpdateText
    End If

End Property

Public Property Let PercentFormat(ByVal varNew As String)
    
    If varNew <> m_PercFmt Then
        m_PercFmt = varNew
        PropertyChanged "PercentFormat"
        
        UpdateText
    End If

End Property

Public Property Let ValueFormat(ByVal varNew As String)
    
    If varNew <> m_ValFmt Then
        m_ValFmt = varNew
        PropertyChanged "ValueFormat"
        
        UpdateText
    End If

End Property

Public Property Let DoAppEvents(ByVal varNew As Boolean)
    
    If m_DoEvents <> varNew Then
        m_DoEvents = varNew
        PropertyChanged "DoAppEvents"
    End If
    
End Property

Private Sub m_Font_FontChanged(ByVal PropertyName As String)
    Dim lpFont As LOGFONT
    
    PropertyChanged "Font"
    
    If m_pFont <> 0& Then
        DeleteObject m_pFont
    End If
    
    GetLogFont m_Font, lpFont, hdc
    m_pFont = CreateFontIndirect(lpFont)
    
    If m_pTextDC <> 0& Then
        SelectObject m_pTextDC, m_pFont
        UpdateText
    End If
    
End Sub

Public Property Set Font(ByVal sFont As StdFont)
    Dim lpFont As LOGFONT
        
    If Not (m_Font Is sFont) Then
        Set m_Font = sFont
        
        If m_pFont <> 0& Then
            DeleteObject m_pFont
        End If
        
        MeasureTextArea
        UserControl_Paint
            
    End If
    
End Property

Public Property Let BorderStyle(ByVal varNew As BorderStyleConstants)
    
    If Ambient.UserMode = False Then
        If m_BorderStyle <> varNew Then
            m_BorderStyle = varNew
            PropertyChanged "BorderStyle"
            UserControl_Paint
        End If
    Else
        Err.Raise 382
    End If

End Property

Public Property Let TextBorderStyle(ByVal varNew As BorderStyleConstants)
    
    If Ambient.UserMode = False Then
        If m_TextBorderStyle <> varNew Then
            m_TextBorderStyle = varNew
            PropertyChanged "TextBorderStyle"
            UserControl_Paint
        End If
    Else
        Err.Raise 382
    End If

End Property

Public Property Let Style(ByVal varNew As ProgressBarStyles)
    
    If Ambient.UserMode = False Then
        If m_Style <> varNew Then
            m_Style = varNew
            PropertyChanged "Style"
            UserControl_Paint
        End If
    Else
        Err.Raise 382
    End If

End Property

Public Property Let Orientation(ByVal varNew As OrientationConstants)
    
    If Ambient.UserMode = False Then
        
        If m_Orientation <> varNew Then
            m_Orientation = varNew
            PropertyChanged "Orientation"
            
            Dim x As Long, _
                y As Long, _
                n As Long
                
            x = Width
            y = Height
            
            If ((x < y) And (varNew And ocHorizontal)) _
                Or ((y < x) And (varNew And ocVertical)) Then
                
                n = x
                x = y
                y = n
                
                Extender.Move Extender.Left, Extender.Top, x, y
                
            End If

            UpdateText
        
            UserControl_Resize
        End If
        
    Else
        Err.Raise 382
    End If

End Property

Public Property Let BackColor(ByVal varNew As OLE_COLOR)
    Dim lpBrush As LOGBRUSH
    
    If varNew <> m_BackColor Then
        m_BackColor = varNew
        
        DeleteObject m_pBrush
        
        lpBrush.lbColor = OleToColor(m_BackColor)
        lpBrush.lbStyle = BS_SOLID
        
        m_pBrush = CreateBrushIndirect(lpBrush)
        
        PropertyChanged "BackColor"
        
        UserControl_Paint
    End If
End Property

Public Property Let ForeColor(ByVal varNew As OLE_COLOR)
    If varNew <> m_ForeColor Then
        m_ForeColor = varNew
        PropertyChanged "ForeColor"
        
        UserControl_Paint
    End If
End Property

Public Property Let TextColor(ByVal varNew As OLE_COLOR)
    
    If varNew <> m_TextColor Then
        m_TextColor = varNew
        PropertyChanged "TextColor"
        
        If m_pTextDC <> 0& Then
            SetTextColor m_pTextDC, OleToColor(m_TextColor)
        End If
        
        UserControl_Paint
    End If
    
End Property

Public Property Let TextBkColor(ByVal varNew As OLE_COLOR)
        
    Dim lpBrush As LOGBRUSH
    
    If varNew <> m_TextBkColor Then
        m_TextBkColor = varNew
        PropertyChanged "TextBkColor"
        
        If m_pTextDC <> 0& Then
            SetBkColor m_pTextDC, OleToColor(m_TextBkColor)
        End If
        
        If (m_pTextBrush <> 0&) Then
            DeleteObject m_pTextBrush
        End If
        
        With lpBrush
            .lbColor = OleToColor(m_TextBkColor)
            .lbStyle = BS_SOLID
        End With
        
        m_pTextBrush = CreateBrushIndirect(lpBrush)
        
        UserControl_Paint
    End If
    
End Property

Public Property Let MaxValue(ByVal varNew As Double)
    If varNew <> m_MaxValue Then
        If varNew <= m_MinValue Then Exit Property
        
        m_MaxValue = varNew
        PropertyChanged "MaxValue"
                
        If (m_Value > m_MaxValue) Then
            m_Value = m_MaxValue
        End If
        
        DrawMagicSquares
    End If
End Property

Public Property Let MinValue(ByVal varNew As Double)
    If varNew <> m_MinValue Then
        If varNew >= m_MaxValue Then Exit Property
        
        m_MinValue = varNew
        PropertyChanged "MinValue"
                
        If (m_Value < m_MinValue) Then
            m_Value = m_MinValue
        End If
        
        DrawMagicSquares
    End If
End Property

Public Property Let Value(ByVal varNew As Double)
    
    
Dim Valorfixo As Long

'mas  bom manter estes codigos

'Valorfixo = varNew

'Valorfixo = Format(Valorfixo, "######.00")

'varNew = Valorfixo
    
    Dim b As Boolean
    
    If (m_Value = varNew) Then
        UserControl_Paint
        Exit Property
    End If
    
    b = (m_Value > varNew)
    m_Value = varNew
    
    If (m_Value > m_MaxValue) Then
        m_Value = m_MaxValue
    ElseIf (m_Value < m_MinValue) Then
        m_Value = m_MinValue
    End If
    
    If (b = True) Then
        UserControl_Paint
    Else
        
        Select Case m_Style
            Case psMagicSquares:
                DrawMagicSquares
                
            Case psFade:
                DrawMagicSquares , True
                
        End Select
    
    End If
    
    PropertyChanged "Value"

End Property

Public Sub Reset()
Attribute Reset.VB_Description = "Reset the value to the minimum value."
    
    m_Value = m_MinValue
    PropertyChanged "Value"
    
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    If (m_TileDown = -1&) And (m_ClickableTiles) Then
        Dim lpPoint As POINTAPI
        
        With lpPoint
            .x = x
            .y = y
        End With
        
        ClickTile lpPoint, False, (m_Style = psFade)
        RaiseEvent TileClick(m_TileDown, MrkCount, Button)
        
    End If

End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

    If (m_TileDown <> -1&) And (m_ClickableTiles) Then
        Dim lpPoint As POINTAPI
        
        With lpPoint
            .x = x
            .y = y
        End With
        
        ClickTile lpPoint, True, (m_Style = psFade)
    End If
    
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    
Exit Sub

    Dim lpBrush As LOGBRUSH, _
        lpFont As LOGFONT
       
    m_Style = PropBag.ReadProperty("Style", m_Style)
    
    m_Orientation = PropBag.ReadProperty("Orientation", m_Orientation)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_BorderStyle)
    m_TextBorderStyle = PropBag.ReadProperty("TextBorderStyle", m_TextBorderStyle)
    m_BackColor = PropBag.ReadProperty("BackColor", m_BackColor)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_ForeColor)
    m_TextColor = PropBag.ReadProperty("TextColor", m_TextColor)
    m_TextBkColor = PropBag.ReadProperty("TextBkColor", m_TextBkColor)
    
    m_TextAreaHeight = PropBag.ReadProperty("TextAreaHeight", m_TextAreaHeight)
    
    m_MaxValue = PropBag.ReadProperty("MaxValue", m_MaxValue)
    m_MinValue = PropBag.ReadProperty("MinValue", m_MinValue)
    m_Value = PropBag.ReadProperty("Value", m_Value)
    
    m_Text = PropBag.ReadProperty("Text", m_Text)
    m_TextAlign = PropBag.ReadProperty("TextAlign", m_TextAlign)
    m_TextVAlign = PropBag.ReadProperty("TextVAlign", m_TextVAlign)
    
    m_DoEvents = PropBag.ReadProperty("DoAppEvents", m_DoEvents)
    m_ClickableTiles = PropBag.ReadProperty("ClickableTiles", m_ClickableTiles)
    
    If m_pBrush <> 0& Then
        DeleteObject m_pBrush
    End If
    
    lpBrush.lbColor = OleToColor(m_BackColor)
    lpBrush.lbHatch = BS_SOLID
    
    m_pBrush = CreateBrushIndirect(lpBrush)
    
    lpBrush.lbColor = OleToColor(m_TextBkColor)
    m_pTextBrush = CreateBrushIndirect(lpBrush)
    
    Set m_Font = PropBag.ReadProperty("Font", m_Font)
    
    GetLogFont m_Font, lpFont, hdc
    
    If m_pFont <> 0& Then
        DeleteObject m_pFont
    End If
        
    MeasureTextArea
    
    m_ValFmt = PropBag.ReadProperty("ValueFormat", m_ValFmt)
    m_PercFmt = PropBag.ReadProperty("PercentFormat", m_PercFmt)
    
    UserControl.Refresh
    
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    
    
    
    Exit Sub
    
    
    PropBag.WriteProperty "Style", m_Style
    
    PropBag.WriteProperty "BorderStyle", m_BorderStyle
    PropBag.WriteProperty "TextBorderStyle", m_TextBorderStyle
    
    PropBag.WriteProperty "Orientation", m_Orientation
    PropBag.WriteProperty "BackColor", m_BackColor
    PropBag.WriteProperty "ForeColor", m_ForeColor
    PropBag.WriteProperty "TextColor", m_TextColor
    PropBag.WriteProperty "TextBkColor", m_TextBkColor
    
    PropBag.WriteProperty "TextAreaHeight", m_TextAreaHeight
    
    PropBag.WriteProperty "MaxValue", m_MaxValue
    PropBag.WriteProperty "MinValue", m_MinValue
    PropBag.WriteProperty "Value", m_Value
    
    PropBag.WriteProperty "DoAppEvents", m_DoEvents
    
    PropBag.WriteProperty "Font", m_Font
    
    PropBag.WriteProperty "ClickableTiles", m_ClickableTiles
    
    PropBag.WriteProperty "Text", m_Text
    PropBag.WriteProperty "TextAlign", m_TextAlign
    PropBag.WriteProperty "TextVAlign", m_TextVAlign
    
    PropBag.WriteProperty "ValueFormat", m_ValFmt
    PropBag.WriteProperty "PercentFormat", m_PercFmt
    
End Sub

Private Sub UserControl_Resize()
    
    If m_pDC <> 0& Then
        DeleteObject m_pBitmap
        
        m_pBitmap = 0&
    End If
    
    If m_pTextDC <> 0& Then
        DeleteObject m_pTextBitmap
        
        m_pTextBitmap = 0&
    End If
    
    MeasureTextArea

End Sub

Private Property Get PixelWidth() As Double
    PixelWidth = Width / 15
End Property

Private Property Get PixelHeight() As Double
    PixelHeight = Height / 15
End Property

Private Sub BltToScreen()
    
    BitBlt hdc, 0&, 0&, PixelWidth, PixelHeight, m_pDC, 0&, 0&, SRCCOPY

End Sub

Private Sub UserControl_Paint()
        
    Dim lpRect As RECT, _
        lpFont As LOGFONT
    
    Dim v As Long
    
    If m_pDC = 0& Then
        m_pDC = CreateCompatibleDC(hdc)
        MeasureTextArea
    End If
    
    If m_pBitmap = 0& Then
        m_pBitmap = CreateCompatibleBitmap(hdc, PixelWidth, PixelHeight)
        SelectObject m_pDC, m_pBitmap
    End If
        
    lpRect.Right = PixelWidth
    lpRect.Bottom = PixelHeight
    
    FillRect m_pDC, lpRect, m_pBrush
        
    lpRect.Bottom = lpRect.Bottom - 1
    lpRect.Right = lpRect.Right - 1
    
    If (m_Orientation And ocHorizontal) Then
        If (m_TextVAlign = taBottom) Then
            lpRect.Bottom = m_TextArea.Top - 1
        Else
            lpRect.Top = m_TextArea.Bottom + 1
        End If
    End If
    
    If (m_BorderStyle <> bsNone) Then
        
        Select Case m_BorderStyle
        
            Case bsSunken3D:
                Draw3DFrame_Sunken m_pDC, lpRect
                
            Case bsRaised3D:
                Draw3DFrame_Raised m_pDC, lpRect
            
            Case bsSunkenBox:
                Draw3DBox_Sunken m_pDC, lpRect
            
            Case bsRaisedBox:
                Draw3DBox_Raised m_pDC, lpRect
        
        End Select
        
    End If
    
    Select Case m_Style
    
        Case psMagicSquares
            DrawMagicSquares True
        
        Case psFade
            DrawMagicSquares True, True
        
    End Select
    
End Sub

Private Sub MeasureTextArea()

    Dim lpSize As SIZEAPI, _
        lpFont As LOGFONT

    If (m_pDC = 0&) Then Exit Sub
    
    If (m_pTextDC <> 0&) Then
        DeleteObject m_pTextBitmap
    End If
    
    If m_pFont = 0& Then
        GetLogFont m_Font, lpFont, m_pDC
        m_pFont = CreateFontIndirect(lpFont)
        
        SelectObject m_pDC, m_pFont
        If (m_pTextDC <> 0&) Then SelectObject m_pTextDC, m_pFont
    End If
        
    MeasureText_API m_pDC, c_AlphaStr, lpSize
    
    If (m_TextAreaHeight > 0&) Then
        lpSize.cy = m_TextAreaHeight
    ElseIf (m_TextAreaHeight <= -1&) Then
        lpSize.cy = 0&
        MrkCount = Markers(MrkSize)
    
        Exit Sub
    End If
    
    With m_TextArea
        
        Select Case m_Orientation
        
            Case ocHorizontal, ocHorizontalRightToLeft
            
                .Left = 0&
                .Right = PixelWidth
                
                Select Case m_TextVAlign
                
                    Case taTop
                        .Top = 0&
                        .Bottom = lpSize.cy + 4
                        
                    Case taBottom
                        .Bottom = PixelHeight
                        .Top = .Bottom - (lpSize.cy + 4)
                                            
                End Select
    
                If (m_pTextDC <> 0&) Then
                    m_pTextBitmap = CreateCompatibleBitmap(hdc, (.Right - .Left) + 1, (.Bottom - .Top) + 1)
                
                    SelectObject m_pTextDC, m_pTextBitmap
                    SelectObject m_pTextDC, m_pFont
            
                    SetTextColor m_pTextDC, OleToColor(m_TextColor)
                    SetBkMode m_pTextDC, TRANSPARENT
                End If
                        
            Case Else
            
                '' text is no longer available in the vertical orientation
                '' as of Version 2.0.
            
                .Top = 0&
                .Bottom = 0&
                .Right = 0&
                .Left = 0&
                    
        End Select
    
    End With
    
    MrkCount = Markers(MrkSize)
    
End Sub

Private Sub UpdateText()
    Dim lpFont As LOGFONT
        
    Dim lpBrush As LOGBRUSH
    
    Dim vText As String, _
        sPVal As Double
        
    Dim lpSize As SIZEAPI, _
        x As Long, _
        y As Long, _
        l As Long
    
    Dim lpRect As RECT
    
    If (m_TextAreaHeight <= -1&) Or (m_pFont = 0&) Or (m_Orientation And ocVertical) Then Exit Sub
    
    If (m_pTextDC = 0&) Then
        m_pTextDC = CreateCompatibleDC(hdc)
        SetBkMode m_pTextDC, TRANSPARENT
        SetBkColor m_pTextDC, OleToColor(m_TextBkColor)
        SetTextColor m_pTextDC, OleToColor(m_TextColor)
        
        SelectObject m_pTextDC, m_pFont
        MeasureTextArea
    End If
    
    If (m_pTextBrush = 0&) Then
        With lpBrush
            .lbColor = OleToColor(m_TextBkColor)
            .lbStyle = BS_SOLID
        End With
        
        m_pTextBrush = CreateBrushIndirect(lpBrush)
    End If
    
    With m_TextArea
        lpRect.Left = 0
        lpRect.Top = 0
        lpRect.Right = (.Right - .Left) + 1
        lpRect.Bottom = (.Bottom - .Top) + 1
    End With
    
    FillRect m_pTextDC, lpRect, m_pTextBrush
        
    With lpRect
        .Right = .Right - 2
        .Bottom = .Bottom - 2
    End With
    
    Select Case m_TextBorderStyle
    
        Case bsSunken3D:
            Draw3DFrame_Sunken m_pTextDC, lpRect
            
        Case bsRaised3D:
            Draw3DFrame_Raised m_pTextDC, lpRect
        
        Case bsSunkenBox:
            Draw3DBox_Sunken m_pTextDC, lpRect
        
        Case bsRaisedBox:
            Draw3DBox_Raised m_pTextDC, lpRect
    
    End Select
    
    
    sPVal = (m_Value / (m_MaxValue - m_MinValue)) * 100
    
    vText = InsertStr(m_Text, "\p", sPVal, m_PercFmt)
    vText = InsertStr(vText, "\v", m_Value, m_ValFmt)
    vText = InsertStr(vText, "\m", m_MaxValue, m_ValFmt)
    vText = InsertStr(vText, "\z", m_MinValue, m_ValFmt)
    
    If m_Text <> "" Then
        
        MeasureText_API m_pTextDC, vText, lpSize
    
        Select Case m_TextAlign
        
            Case taRight:
        
                x = lpRect.Right - (lpSize.cx + 6)
                
            Case taLeft:
            
                x = 4&
            
            Case taCenter:
            
                x = (lpRect.Right / 2) - (lpSize.cx / 2)
            
        End Select
        
        y = (lpRect.Bottom / 2) - (lpSize.cy / 2)
                                                
        TextOut_API m_pTextDC, vText, x, y
        
    End If

    With m_TextArea
        BitBlt m_pDC, .Left, .Top, lpRect.Right + 1, lpRect.Bottom + 1, m_pTextDC, 0&, 0&, SRCCOPY
    End With
    
End Sub

Private Sub DrawMagicSquares(Optional ByVal RepaintAll As Boolean, Optional ByVal Fade As Boolean)

    Dim lpGradient As GRADIENTSTRUCT, _
        lpRect As RECT, _
        lpSize As SIZEAPI, _
        lpPoint As POINTAPI
        
    Dim lpBrush As LOGBRUSH, _
        hBrush As Long
        
    Dim x As Double, _
        y As Long, _
        n As Long
        
    Dim s As Double, _
        t As Double, _
        u As Double
            
    Dim sStart As Double
    
    Static rcPos As Long
        
    If MrkCount = 0& Then Exit Sub
    
    With lpGradient
        
        .BaseColor = OleToColor(m_BackColor)
        .FinalColor = OleToColor(m_ForeColor)
    
    End With
    
    If (Fade) Then x = 1 Else _
        x = MrkCount
        
    If (Fade) Then
        If (m_Orientation And ocHorizontal) Then
            lpSize.cx = PixelWidth - 4
            lpSize.cy = MrkSize.cy
        Else
            lpSize.cx = MrkSize.cx
            lpSize.cy = PixelHeight - 4
        End If
    Else
        lpSize.cx = MrkSize.cx
        lpSize.cy = MrkSize.cy
    End If
               
    s = (m_MaxValue - m_MinValue) / x
        
    If Not RepaintAll = True Then
        t = (m_Value - m_MinValue) / x
    
        If Round(t) < t Then
            t = Round(t) + 1
        Else
            t = Round(t)
        End If
        
        If rcPos <> t Then
        
            rcPos = t
            sStart = m_MinValue
        
        Else
        
            For u = m_MinValue To m_Value Step s
            
                If (u + s) > m_Value Then
                    sStart = u
                    Exit For
                End If
                
                y = y + 1
            
            Next u
        
        End If
        
    Else
        
        sStart = m_MinValue
    
    End If
    
    hBrush = 0&
    For u = sStart To m_Value Step s
        
        If ((u + s) > m_Value) Then
            
            If CSng(m_MaxValue - m_Value) < Abs(s) Then
                t = 1# - (CSng(m_MaxValue - m_Value) / Abs(s))
            Else
                t = (m_Value - u) / Abs(s)
            End If
            
            lpGradient.Percentage = t
            
            If hBrush <> 0& Then
                DeleteObject hBrush
            End If
            
            lpBrush.lbColor = GetGradColor(lpGradient)
            hBrush = CreateBrushIndirect(lpBrush)
            
        Else
            If hBrush = 0& Then
                lpBrush.lbColor = lpGradient.FinalColor
                lpBrush.lbStyle = BS_SOLID
                
                hBrush = CreateBrushIndirect(lpBrush)
            End If
        End If
        
        Select Case m_Orientation
            
            Case ocHorizontal:
                
                lpRect.Top = 2
                lpRect.Left = (y * (lpSize.cx + 1)) + 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Right < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Left < 2 Then
                    lpRect.Left = 2
                End If
                
                If lpRect.Left > (PixelWidth - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Right > (PixelWidth - 2) Then
                    lpRect.Right = PixelWidth - 2
                End If
                
                If (m_TextVAlign = taTop) Then
                    ShiftRect lpRect, 0, m_TextArea.Bottom
                End If
                
            Case ocHorizontalRightToLeft:
                                
                lpRect.Top = 2
                lpRect.Left = PixelWidth - (((y + 1) * (lpSize.cx + 1)) + 2)
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Right < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Left < 2 Then
                    lpRect.Left = 2
                End If
                
                If lpRect.Left > (PixelWidth - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Right > (PixelWidth - 2) Then
                    lpRect.Right = PixelWidth - 2
                End If
                
                If (m_TextVAlign = taTop) Then
                    ShiftRect lpRect, 0, m_TextArea.Bottom
                End If
            
            Case ocVertical:
            
                lpRect.Top = (y * (lpSize.cy + 1)) + 2
                lpRect.Left = 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Bottom < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Top < 2 Then
                    lpRect.Top = 2
                End If
                
                If lpRect.Top > (PixelHeight - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Bottom > (PixelHeight - 2) Then
                    lpRect.Bottom = PixelHeight - 2
                End If
                
            Case ocVerticalBottomToTop:
        
                lpRect.Top = PixelHeight - (((y + 1) * (lpSize.cy + 1)) + 2)
                lpRect.Left = 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                                                       
                If lpRect.Bottom < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Top < 2 Then
                    lpRect.Top = 2
                End If
                
                If lpRect.Top > (PixelHeight - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Bottom > (PixelHeight - 2) Then
                    lpRect.Bottom = PixelHeight - 2
                End If
                
        End Select
        
        If lpRect.Left <> -1& Then
            FillRect m_pDC, lpRect, hBrush
            
            With lpRect
                .Right = .Right - 1
                .Bottom = .Bottom - 1
            End With
            
            If (m_ClickableTiles = True) And (m_Value <> 0&) Then
                
                If (m_TileDown = y) Then
                    Draw3DBox_Sunken m_pDC, lpRect
                Else
                    Draw3DBox_Raised m_pDC, lpRect
                End If
            
            End If
        End If
        
        y = y + 1
        
    Next u
    
    DeleteObject hBrush
    UpdateText
    BltToScreen
    
    If m_DoEvents Then
        DoEvents
    End If
        
End Sub

Private Sub ClickTile(Mouse As POINTAPI, Optional ByVal Unclick As Boolean, Optional ByVal Fade As Boolean)

    Dim lpRect As RECT, _
        lpSize As SIZEAPI, _
        lpPoint As POINTAPI
        
    Dim x As Double, _
        y As Long, _
        n As Long
        
    Dim s As Double, _
        t As Double, _
        u As Double
            
    Dim sStart As Double
    
    If (MrkCount = 0&) Or (m_Value = 0&) Then Exit Sub
    
    If (Fade) Then x = 1 Else _
        x = MrkCount
        
    If (Fade) Then
        If (m_Orientation And ocHorizontal) Then
            lpSize.cx = PixelWidth - 4
            lpSize.cy = MrkSize.cy
        Else
            lpSize.cx = MrkSize.cx
            lpSize.cy = PixelHeight - 4
        End If
    Else
        lpSize.cx = MrkSize.cx
        lpSize.cy = MrkSize.cy
    End If
               
    s = (m_MaxValue - m_MinValue) / x
            
    sStart = m_MinValue
    
    For u = sStart To m_Value Step s
        
        Select Case m_Orientation
            
            Case ocHorizontal:
                
                lpRect.Top = 2
                lpRect.Left = (y * (lpSize.cx + 1)) + 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Right < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Left < 2 Then
                    lpRect.Left = 2
                End If
                
                If lpRect.Left > (PixelWidth - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Right > (PixelWidth - 2) Then
                    lpRect.Right = PixelWidth - 2
                End If
                
                If (m_TextVAlign = taTop) Then
                    ShiftRect lpRect, 0, m_TextArea.Bottom
                End If
                
            Case ocHorizontalRightToLeft:
                                                                
                lpRect.Top = 2
                lpRect.Left = PixelWidth - (((y + 1) * (lpSize.cx + 1)) + 2)
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Right < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Left < 2 Then
                    lpRect.Left = 2
                End If
                
                If lpRect.Left > (PixelWidth - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Right > (PixelWidth - 2) Then
                    lpRect.Right = PixelWidth - 2
                End If
                
                If (m_TextVAlign = taTop) Then
                    ShiftRect lpRect, 0, m_TextArea.Bottom
                End If
            
            Case ocVertical:
            
                lpRect.Top = (y * (lpSize.cy + 1)) + 2
                lpRect.Left = 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Bottom < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Top < 2 Then
                    lpRect.Top = 2
                End If
                
                If lpRect.Top > (PixelHeight - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Bottom > (PixelHeight - 2) Then
                    lpRect.Bottom = PixelHeight - 2
                End If
                
            Case ocVerticalBottomToTop:
        
                lpRect.Top = PixelHeight - (((y + 1) * (lpSize.cy + 1)) + 2)
                lpRect.Left = 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                                                       
                If lpRect.Bottom < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Top < 2 Then
                    lpRect.Top = 2
                End If
                
                If lpRect.Top > (PixelHeight - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Bottom > (PixelHeight - 2) Then
                    lpRect.Bottom = PixelHeight - 2
                End If
                
        End Select
        
        If lpRect.Left <> -1& Then
            If (WithinRect(lpRect, Mouse.x, Mouse.y) = True) Or (m_TileDown = y) Then
            
                With lpRect
                    .Right = .Right - 1
                    .Bottom = .Bottom - 1
                End With
                
                If (Unclick = True) Then
                    Draw3DBox_Raised m_pDC, lpRect
                    m_TileDown = -1&
                Else
                    m_TileDown = y
                    Draw3DBox_Sunken m_pDC, lpRect
                End If
            End If
        End If
        
        y = y + 1
        
    Next u
    
    BltToScreen
    
End Sub

Private Function Markers(lpSize As SIZEAPI) As Double
    Dim mH As Long, _
        mW As Long
    
    If (m_Orientation And ocVertical) Then
        
        mW = PixelWidth - 4
        mH = mW
    
        Markers = ((PixelHeight - 3) / (mH + 1))
        
    ElseIf (m_Orientation And ocHorizontal) Then
    
        mH = PixelHeight - 4
        
        mH = mH - ((m_TextArea.Bottom - m_TextArea.Top) + 1)
        mW = mH
        
        Markers = ((PixelWidth - 3) / (mW + 1))
            
    End If
    
    If Round(Markers) < Markers Then
        If (Markers - Round(Markers)) >= 0.2 Then
            Markers = Round(Markers) + 1
        Else
            Markers = Round(Markers)
        End If
    Else
        Markers = Round(Markers)
    End If
        
    lpSize.cx = mW
    lpSize.cy = mH
        
End Function

Private Sub UserControl_Initialize()
        
    Dim lpBrush As LOGBRUSH

    m_BorderStyle = bsSunken3D
    m_TextBorderStyle = bsRaised3D
    
    m_Orientation = ocVerticalBottomToTop
    
    m_BackColor = &H80000000 + COLOR_BTNFACE
    m_ForeColor = &H80000000 + COLOR_HIGHLIGHT
    
    m_TextColor = &H80000000 + COLOR_BTNTEXT
    m_TextBkColor = &H80000000 + COLOR_BTNFACE
    
    m_Style = psMagicSquares
    
    m_Value = 0#
    m_MaxValue = 100#
    m_MinValue = 0#
        
    Set m_Font = New StdFont
    
    lpBrush.lbColor = OleToColor(m_BackColor)
    lpBrush.lbHatch = BS_SOLID
    
    m_pBrush = CreateBrushIndirect(lpBrush)

    m_Text = "\p%"
    
    m_TextAlign = taCenter
    m_TextVAlign = taBottom
    
    m_ValFmt = "#####0.00"
    m_PercFmt = "##0&"

    m_TileDown = -1&
    
End Sub

Private Sub UserControl_Terminate()

    If m_pDC <> 0& Then
        DeleteDC m_pDC
        DeleteObject m_pBitmap
    End If
    
    If m_pTextDC <> 0& Then
        DeleteObject m_pTextDC
        DeleteObject m_pTextBitmap
    End If
    
    DeleteObject m_pBrush
    DeleteObject m_pFont
    
    DeleteObject m_pTextBrush
    
End Sub



Private Sub CheckUnicode()
    Dim lpOS As OSVERSIONINFO
    
    lpOS.OSVersionInfoSize = Len(lpOS)
    GetVersion lpOS
    
    If (lpOS.PlatformId = VER_PLATFORM_WIN32_NT) Then
        Using_Unicode = True
        
    Else
        Using_Unicode = False
    End If
    
    Unicode_Checked = True
    Using_Unicode = False
    
    
End Sub


''' Draw 3D Borders

'' Heavy Raised (3D Buttons, Forms or Menus)

Private Function Draw3DFrame_Raised(ByVal hdc As Long, lpRect As RECT, Optional ByVal dwPenStyle As Long = PS_SOLID)
    Dim hPen As Long, _
        x As Long, _
        y As Long, _
        lpPoint As POINTAPI
    
    Dim hOldPen As Long, _
        crColor As Long
        
    With lpRect
        crColor = GetSysColor(COLOR_3DLIGHT)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        hOldPen = SelectObject(hdc, hPen)
    
        x = .Left
        y = .Bottom
        
        MoveToEx hdc, x, y, lpPoint
        y = .Top
        
        LineTo hdc, x, y
        x = .Right
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_BTNHIGHLIGHT)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Left + 1&
        y = .Bottom - 1&
        
        MoveToEx hdc, x, y, lpPoint
        y = .Top + 1&
        
        LineTo hdc, x, y
        x = .Right - 1&
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_3DDKSHADOW)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Right
        y = .Top
        
        MoveToEx hdc, x, y, lpPoint
        y = .Bottom
        LineTo hdc, x, y
        
        x = .Left
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_BTNSHADOW)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Right - 1&
        y = .Top + 1&
        
        MoveToEx hdc, x, y, lpPoint
        y = .Bottom - 1&
        LineTo hdc, x, y
        
        x = .Left + 1&
        LineTo hdc, x, y
    
    End With
            
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
End Function


'' Heavy Sunken (3D Controls)

Private Function Draw3DFrame_Sunken(ByVal hdc As Long, lpRect As RECT, Optional ByVal dwPenStyle As Long = PS_SOLID)
    Dim hPen As Long, _
        x As Long, _
        y As Long, _
        lpPoint As POINTAPI
    
    Dim hOldPen As Long, _
        crColor As Long
        
    With lpRect
        crColor = GetSysColor(COLOR_3DDKSHADOW)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        hOldPen = SelectObject(hdc, hPen)
    
        x = .Left
        y = .Bottom
        
        MoveToEx hdc, x, y, lpPoint
        y = .Top
        
        LineTo hdc, x, y
        x = .Right
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_BTNSHADOW)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Left + 1&
        y = .Bottom - 1&
        
        MoveToEx hdc, x, y, lpPoint
        y = .Top + 1&
        
        LineTo hdc, x, y
        x = .Right - 1&
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_BTNHIGHLIGHT)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Right
        y = .Top
        
        MoveToEx hdc, x, y, lpPoint
        y = .Bottom
        LineTo hdc, x, y
        
        x = .Left
        LineTo hdc, x, y
        
            
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_3DLIGHT)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Right - 1&
        y = .Top + 1&
        
        MoveToEx hdc, x, y, lpPoint
        y = .Bottom - 1&
        LineTo hdc, x, y
        
        x = .Left + 1&
        LineTo hdc, x, y
    
    End With
            
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
End Function

'' Light Raised (Highlighted/Bordered)

Private Function Draw3DBox_Raised(ByVal hdc As Long, lpRect As RECT)

    Dim hPen As Long, _
        hOldPen As Long
    
    Dim lpPoint As POINTAPI
        
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
    
    hOldPen = SelectObject(hdc, hPen)
    
    MoveToEx hdc, lpRect.Right, lpRect.Top, lpPoint
    LineTo hdc, lpRect.Left, lpRect.Top
    LineTo hdc, lpRect.Left, lpRect.Bottom
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW))
    
    SelectObject hdc, hPen
    
    MoveToEx hdc, lpRect.Right, lpRect.Top, lpPoint
    LineTo hdc, lpRect.Right, lpRect.Bottom
    LineTo hdc, lpRect.Left, lpRect.Bottom
    
    SelectObject hdc, hOldPen
    DeleteObject hPen

End Function

'' Light Sunken (Selected/Bordered)

Private Function Draw3DBox_Sunken(ByVal hdc As Long, lpRect As RECT)

    Dim hPen As Long, _
        hOldPen As Long
    
    Dim lpPoint As POINTAPI
        
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW))
    
    hOldPen = SelectObject(hdc, hPen)
    
    MoveToEx hdc, lpRect.Right, lpRect.Top, lpPoint
    LineTo hdc, lpRect.Left, lpRect.Top
    LineTo hdc, lpRect.Left, lpRect.Bottom
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
    
    SelectObject hdc, hPen
    
    MoveToEx hdc, lpRect.Right, lpRect.Top, lpPoint
    LineTo hdc, lpRect.Right, lpRect.Bottom
    LineTo hdc, lpRect.Left, lpRect.Bottom
    
    SelectObject hdc, hOldPen
    DeleteObject hPen

End Function

'' Dotted Work Frame

Private Function DrawWorkFrame(ByVal hdc As Long, lpRect As RECT)
    Dim hPen As Long, _
        hOldPen As Long
        
    Dim lpPoint As POINTAPI
        
    hPen = CreatePen(PS_DOT, 1&, GetSysColor(COLOR_HIGHLIGHT))
    hOldPen = SelectObject(hdc, hPen)
    
    With lpRect
        MoveToEx hdc, .Left, .Top, lpPoint

        LineTo hdc, .Right, .Top
        LineTo hdc, .Right, .Bottom
        LineTo hdc, .Left, .Bottom
        LineTo hdc, .Left, .Top
    
        MoveToEx hdc, .Left + 1, .Top + 1, lpPoint

        LineTo hdc, .Right - 1, .Top + 1
        LineTo hdc, .Right - 1, .Bottom - 1
        LineTo hdc, .Left + 1, .Bottom - 1
        LineTo hdc, .Left + 1, .Top + 1
    
    End With
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
End Function

Private Function BevelBox(ByVal hdc As Long, lpRect As RECT, Optional ByVal Reversed As Boolean)
        
    Dim rcFill As RECT, _
        lpBrush As LOGBRUSH, _
        hBrush As Long
                
    Dim hPen As Long, _
        hOldPen As Long
                
    Dim lpPoint As POINTAPI
    
    If (Reversed = True) Then
        hPen = CreatePen(PS_SOLID, 2&, GetSysColor(COLOR_BTNHIGHLIGHT))
        lpBrush.lbColor = GetSysColor(COLOR_BTNSHADOW)
    Else
        hPen = CreatePen(PS_SOLID, 2&, GetSysColor(COLOR_BTNSHADOW))
        lpBrush.lbColor = GetSysColor(COLOR_BTNHIGHLIGHT)
    End If
    
    lpBrush.lbStyle = BS_SOLID
    
    hOldPen = SelectObject(hdc, hPen)
    hBrush = CreateBrushIndirect(lpBrush)
                
    With rcFill
        .Left = lpRect.Right - 1&
        .Top = lpRect.Top
        .Right = lpRect.Right
        .Bottom = lpRect.Bottom
    End With
    
    FillRect hdc, rcFill, hBrush
    
    With rcFill
        MoveToEx hdc, .Left, .Top + 1&, lpPoint
        LineTo hdc, .Left, .Bottom - 1&
    End With

    With rcFill
        .Left = lpRect.Left
        .Top = lpRect.Bottom - 1&
        .Right = lpRect.Right
        .Bottom = lpRect.Bottom
    End With
    
    FillRect hdc, rcFill, hBrush
    
    With rcFill
        MoveToEx hdc, .Left + 1&, .Top, lpPoint
        LineTo hdc, .Right - 1&, .Top
    End With

    DeleteObject hBrush
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
    If (Reversed = True) Then
        hPen = CreatePen(PS_SOLID, 2&, GetSysColor(COLOR_BTNSHADOW))
        lpBrush.lbColor = GetSysColor(COLOR_BTNHIGHLIGHT)
    Else
        hPen = CreatePen(PS_SOLID, 2&, GetSysColor(COLOR_BTNHIGHLIGHT))
        lpBrush.lbColor = GetSysColor(COLOR_BTNSHADOW)
    End If
    
    lpBrush.lbStyle = BS_SOLID
    
    SelectObject hdc, hPen
    hBrush = CreateBrushIndirect(lpBrush)
    
    With rcFill
        .Left = lpRect.Left
        .Top = lpRect.Top + 1&
        .Right = lpRect.Left + 1&
        .Bottom = lpRect.Bottom - 1&
    End With
    
    FillRect hdc, rcFill, hBrush
    
    With rcFill
        MoveToEx hdc, .Right, .Top, lpPoint
        LineTo hdc, .Right, .Bottom
    End With
                
    With rcFill
        .Left = lpRect.Left + 1&
        .Top = lpRect.Top
        .Right = lpRect.Right - 1&
        .Bottom = lpRect.Top + 1&
    End With
    
    FillRect hdc, rcFill, hBrush
    
    With rcFill
        MoveToEx hdc, .Left, .Bottom, lpPoint
        LineTo hdc, .Right, .Bottom
    End With
    
    DeleteObject hBrush
    
    SelectObject hdc, hOldPen
    DeleteObject hPen

End Function


Private Function FlatBox(ByVal hdc As Long, lpRect As RECT, ByVal crColor As Long, Optional ByVal crBackColor As Long = -1&)
        
    Dim hPen As Long, _
        hOldPen As Long
        
    Dim lpPoint As POINTAPI, _
        lpBrush As LOGBRUSH, _
        hBrush As Long
        
    If (crBackColor <> -1&) Then
        lpBrush.lbColor = GetActualColor(crBackColor)
        lpBrush.lbStyle = BS_SOLID
        
        hBrush = CreateBrushIndirect(lpBrush)
        FillRect hdc, lpRect, hBrush
        
        DeleteObject hBrush
    End If
    
    hPen = CreatePen(PS_SOLID, 1&, crColor)
    hOldPen = SelectObject(hdc, hPen)
    
    With lpRect
        MoveToEx hdc, .Left, .Top, lpPoint
        
        LineTo hdc, .Left, .Bottom
        LineTo hdc, .Right, .Bottom
        LineTo hdc, .Right, .Top
        LineTo hdc, .Left, .Top
    End With
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
        
End Function


'' Bevel Line

Private Function BevelLine(ByVal hdc As Long, PointA As POINTAPI, PointB As POINTAPI, Optional ByVal Vertical As Boolean, Optional ByVal Inverse As Boolean)

    Dim hPen As Long, _
        lpPoint As POINTAPI, _
        hOldPen As Long
        
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
    hOldPen = SelectObject(hdc, hPen)
    
    MoveToEx hdc, PointA.x, PointA.y, lpPoint
    LineTo hdc, PointB.x, PointB.y
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW))
    SelectObject hdc, hPen
        
    If (Vertical = True) Then
        
        If Inverse = True Then
            MoveToEx hdc, PointA.x - 1, PointA.y, lpPoint
            LineTo hdc, PointB.x - 1, PointB.y
        Else
            MoveToEx hdc, PointA.x + 1, PointA.y, lpPoint
            LineTo hdc, PointB.x + 1, PointB.y
        End If
    Else
        If Inverse = True Then
            MoveToEx hdc, PointA.x, PointA.y + 1, lpPoint
            LineTo hdc, PointB.x, PointB.y + 1
        Else
            MoveToEx hdc, PointA.x, PointA.y - 1, lpPoint
            LineTo hdc, PointB.x, PointB.y - 1
        End If
    End If
    
    SelectObject hdc, hOldPen
    DeleteObject hPen

    MoveToEx hdc, lpPoint.x, lpPoint.y, lpPoint
    
End Function


'''' Text Rendering / Measuring Functions


'' Unicode Text Measure

Private Function MeasureText_API(ByVal hdc As Long, ByVal lpszText As String, _
                                lpSize As SIZEAPI, _
                                Optional ByVal fHasAccel As Boolean) As Long
                                 
    Dim cx As Long, _
        cy As Long
        
    Dim i As Long, _
        j As Long
        
    Dim cMeasure As SIZEAPI
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        x As Long
                
    Dim sStr As String
                
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                        
        sStr = lpszText
                
        lSize = Len(sStr)
        
        If (Using_Unicode = True) Then
            x = (lSize * 2&)
            ReDim bLine(0& To (x + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(sStr), x
            lpPtr = VarPtr(bLine(0&))
            
            GetTextExtentPoint32W hdc, lpPtr, lSize, cMeasure
            Erase bLine
        Else
            sStr = StrConv(sStr, vbFromUnicode)
            x = LenB(sStr)
            ReDim bLine(0& To (x + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(sStr), x
            lpPtr = VarPtr(bLine(0&))
            
            GetTextExtentPoint32 hdc, lpPtr, x, cMeasure
            Erase bLine
        End If
    
        If (cx < cMeasure.cx) Then cx = cMeasure.cx
        cy = cy + cMeasure.cy
        
    lpSize.cx = cx
    lpSize.cy = cy
        
    If (lSize <> 0&) Then
        MeasureText_API = True
    End If
    
End Function



Private Function MeasureLines_API(ByVal hdc As Long, lpLines() As String, _
                                lpSize As SIZEAPI, _
                                Optional ByVal fHasAccel As Boolean) As Long
                                 
    Dim cx As Long, _
        cy As Long
        
    Dim i As Long, _
        j As Long
        
    Dim cMeasure As SIZEAPI
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        x As Long
                            
                
    Dim sStr As String
                
    If (Unicode_Checked = False) Then CheckUnicode
        
    On Error Resume Next
                    
    i = -1&
    i = UBound(lpLines)
    
    For j = 0 To i
        
        sStr = lpLines(j)
        lSize = Len(sStr)
        
        If (Using_Unicode = True) Then
            x = (lSize * 2&)
            ReDim bLine(0& To (x + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(sStr), x
            lpPtr = VarPtr(bLine(0&))
            
            GetTextExtentPoint32W hdc, lpPtr, lSize, cMeasure
            Erase bLine
        Else
            sStr = StrConv(sStr, vbFromUnicode)
            x = LenB(sStr)
            ReDim bLine(0& To (x + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(sStr), x
            lpPtr = VarPtr(bLine(0&))
            
            GetTextExtentPoint32 hdc, lpPtr, x, cMeasure
            Erase bLine
        End If
    
        If (cx < cMeasure.cx) Then cx = cMeasure.cx
        cy = cy + cMeasure.cy
        
    Next j
            
    lpSize.cx = cx
    lpSize.cy = cy
        
    If (lSize <> 0&) Then
        MeasureLines_API = True
    End If
    
End Function



'' Unicode Text Write Functions

'' TextOut
Private Function TextOut_API(ByVal hdc As Long, ByVal lpszText As String, _
                            ByVal x As Long, ByVal y As Long) As Long


    Dim i As Long, _
        j As Long
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        n As Long
               
    Dim szText As String
                
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                
        lSize = Len(lpszText)
        
        If (Using_Unicode = True) Then
            n = (lSize * 2&)
            ReDim bLine(0& To (n + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(lpszText), n
            lpPtr = VarPtr(bLine(0&))
            
            TextOutW hdc, x, y, lpPtr, lSize
            Erase bLine
        Else
            szText = StrConv(lpszText, vbFromUnicode)
            n = LenB(szText)
            ReDim bLine(0& To n)
            
            CopyMemory bLine(0&), ByVal StrPtr(szText), n
            lpPtr = VarPtr(bLine(0&))
            
            TextOut hdc, x, y, lpPtr, n
            Erase bLine
        End If
    
End Function

'' Draw-Disabled
Private Function DrawDisabled_API(ByVal hdc As Long, ByVal lpszText As String, _
                                 ByVal x As Long, ByVal y As Long) As Long


    Dim i As Long, _
        j As Long
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        n As Long
    
    Dim szText As String
    
    n = 0&
    lpPtr = 0&
    
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                
        lSize = Len(lpszText)
        
        If (lSize = 0&) Then
            Exit Function
        End If
        
        If (Using_Unicode = True) Then
            n = (lSize * 2&)
            ReDim bLine(0& To (n + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(lpszText), n
            lpPtr = VarPtr(bLine(0&))
        
            DrawStateW hdc, 0&, 0&, lpPtr, lSize, x, y, 0&, 0&, (DST_TEXT Or DSS_DISABLED)
        Else
            szText = StrConv(lpszText, vbFromUnicode)
            
            n = LenB(szText)
            ReDim bLine(0& To n)
            
            CopyMemory bLine(0&), ByVal StrPtr(szText), n
            lpPtr = VarPtr(bLine(0&))
            
            DrawState hdc, 0&, 0&, lpPtr, n, x, y, 0&, 0&, (DST_TEXT Or DSS_DISABLED)
        End If
        
        Erase bLine
        
End Function
                            

'' Draw-State
Private Function DrawStateText_API(ByVal hdc As Long, ByVal lpszText As String, _
                                  ByVal x As Long, ByVal y As Long, ByVal uFlags As Long, Optional ByVal hBrush As Long) As Long


    Dim i As Long, _
        j As Long
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        n As Long
    
    Dim szText As String
    
    n = 0&
    lpPtr = 0&
    
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                
        lSize = Len(lpszText)
        
        If (lSize = 0&) Then
            Exit Function
        End If
        
        If (Using_Unicode = True) Then
            n = (lSize * 2&)
            ReDim bLine(0& To (n + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(lpszText), n
            lpPtr = VarPtr(bLine(0&))
        
            DrawStateW hdc, hBrush, 0&, lpPtr, lSize, x, y, 0&, 0&, (DST_TEXT Or uFlags)
        Else
            szText = StrConv(lpszText, vbFromUnicode)
            
            n = LenB(szText)
            ReDim bLine(0& To n)
            
            CopyMemory bLine(0&), ByVal StrPtr(szText), n
            lpPtr = VarPtr(bLine(0&))
            
            DrawState hdc, hBrush, 0&, lpPtr, n, x, y, 0&, 0&, (DST_TEXT Or uFlags)
        End If
        
        Erase bLine
        
End Function
                            
'' DrawText
Private Function DrawText_API(ByVal hdc As Long, ByVal lpszText As String, _
                             lpRect As RECT) As Long


    Dim i As Long, _
        j As Long
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        n As Long
                
    Dim szText As String
                
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                
        lSize = Len(lpszText)
        
        If (Using_Unicode = True) Then
            n = (lSize * 2&)
            ReDim bLine(0& To (n + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(lpszText), n
            lpPtr = VarPtr(bLine(0&))
            
            DrawTextW hdc, lpPtr, lSize, lpRect, 0&
            Erase bLine
        Else
            szText = StrConv(lpszText, vbFromUnicode)
            n = LenB(szText)
            ReDim bLine(0 To n)
            
            CopyMemory bLine(0&), ByVal StrPtr(szText), n
            lpPtr = VarPtr(bLine(0&))
            
            DrawText hdc, lpPtr, n, lpRect, 0&
            Erase bLine
        End If
    
End Function

''' Copyright (C) 2001 Nathan Moschkin

''' ****************** NOT FOR COMMERCIAL USE *****************
''' Inquire if you would like to use this code commercially.
''' Unauthorized recompilation and/or re-release for commercial
''' use is strictly prohibited.
'''
''' please send changes made to code to me at the address, below,
''' if you plan on making those changes privately available.

''' e-mail questions or comments to logeist@tampabay.rr.com





Private Function Draw3DSquare(ByVal hdc As Long, rcBounds As RECT, Optional ByVal Etch As Boolean, Optional ByVal Raised As Boolean)

    Dim hPen1 As Long, _
        hPen2 As Long, _
        hOldPen As Long, _
        lpPoint As POINTAPI
    
    Dim x As Long, _
        y As Long, _
        X2 As Long, _
        Y2 As Long
        
    If Etch Then
        hPen1 = CreatePen(PS_SOLID, 1&, GetSysColor(COLOR_BTNSHADOW))
    Else
        hPen1 = CreatePen(PS_SOLID, 1&, GetSysColor(COLOR_WINDOWFRAME))
    End If
    
    hPen2 = CreatePen(PS_SOLID, 1&, GetSysColor(COLOR_BTNHIGHLIGHT))
    
    x = rcBounds.Left
    y = rcBounds.Top
    
    X2 = rcBounds.Right
    Y2 = rcBounds.Bottom
    
    If (Raised And True) Then
        hOldPen = SelectObject(hdc, hPen2)
    
        '' Draw bottom and right corners first
        
        MoveToEx hdc, x, Y2, lpPoint
        
        LineTo hdc, x, y
        LineTo hdc, X2, y
        
        SelectObject hdc, hPen1
                
        LineTo hdc, X2, Y2
        LineTo hdc, x, Y2
        
    Else
        hOldPen = SelectObject(hdc, hPen1)
    
        '' Draw left and top corners first
        
        MoveToEx hdc, x, Y2, lpPoint
        
        LineTo hdc, x, y
        LineTo hdc, X2, y
        
        SelectObject hdc, hPen2
                
        LineTo hdc, X2, Y2
        LineTo hdc, x, Y2
        
    End If
        
    SelectObject hdc, hOldPen
    DeleteObject hPen1
    DeleteObject hPen2
    
End Function

Private Function OleToColor(ByVal OleColor As OLE_COLOR) As Long

    If (OleColor And &H80000000) Then
        OleToColor = GetSysColor(OleColor And &HFF&)
    Else
        OleToColor = OleColor
    End If
End Function

Private Sub ColorToRGB(ByVal ColorRef As Long, Red As Byte, Green As Byte, Blue As Byte)

    Red = (ColorRef And &HFF&)
    Green = (ColorRef And &HFF00&) / &H100&
    Blue = (ColorRef And &HFF0000) / &H10000

End Sub

Private Function GetGradColor(lpGradient As GRADIENTSTRUCT) As Long

    Dim lpRgb As RGB, _
        lpFinalRgb As RGB
                    
    Dim c As Single
                
    Dim d As Integer, _
        e As Integer, _
        f As Integer
                                
    Dim x As Integer, _
        y As Integer, _
        z As Integer
        
    With lpGradient
        ColorToRGB .BaseColor, lpRgb.Red, lpRgb.Green, lpRgb.Blue
        ColorToRGB .FinalColor, lpFinalRgb.Red, lpFinalRgb.Green, lpFinalRgb.Blue
    
        c = .Percentage
    
    End With
    
    'd = (CInt(lpFinalRgb.Red) - CInt(lpRgb.Red)) * c
    'e = (CInt(lpFinalRgb.Green) - CInt(lpRgb.Green)) * c
    'f = (CInt(lpFinalRgb.Blue) - CInt(lpRgb.Blue)) * c
    
   d = CInt(lpRgb.Red) '+ d
   e = CInt(lpRgb.Green) '+ e
 f = CInt(lpRgb.Blue) '+ 'f
        
    
    GetGradColor = RGB(d, e, f)

End Function

Private Function InsertStr(ByVal StrIn As String, ByVal StrEscape As String, Value, Optional FmtStr As String) As String

    Dim i As Long, _
        s1 As String, _
        s2 As String
        
    i = InStr(1, StrIn, StrEscape)
    If i = 0 Then
        InsertStr = StrIn
        Exit Function
    End If
    
    s1 = Mid(StrIn, 1, i - 1)
    s2 = Mid(StrIn, i + Len(StrEscape))
    
    s1 = s1 & Value & s2
    
    InsertStr = s1
    
End Function

Private Sub StringToCStr(ByVal vData As String, vCStr() As Byte, Optional ByVal FixedLen As Boolean)
    Dim i As Long, _
        s As String
    
    i = Len(vData)
    
    If (FixedLen = False) Then
        ReDim vCStr(0 To i)
    End If
    s = StrConv(vData, vbFromUnicode)
    CopyMemory vCStr(LBound(vCStr)), ByVal StrPtr(s), i
    
End Sub

Private Sub GetLogFont(OleFont As StdFont, lfData As LOGFONT, hdc As Long)

    With lfData
        .lfCharSet = OleFont.Charset
        .lfItalic = OleFont.Italic
        .lfWeight = OleFont.Weight
        
        If OleFont.Bold Then
            .lfWeight = 700
        End If
        
        .lfUnderline = OleFont.Underline
        StringToCStr OleFont.Name, .lfFaceName, True
        .lfStrikeOut = OleFont.Strikethrough
        .lfHeight = -(MulDiv(OleFont.Size, GetDeviceCaps(hdc, LOGPIXELSY), 72))
        .lfQuality = 2
        
    End With

End Sub



